/*******************************************************************************
Copyright (C) 2008, LUMANTEK Co., Ltd.,  (http://www.lumantek.com)

Ventus.h

Common Definitions & Declarations for Application & Library.
*******************************************************************************/

#ifndef VENTUS_H
#define VENTUS_H

#ifdef VTS_API_USE_NAMESPACE
namespace VtsAPINET {
#endif

#define VTS_VERSION_STRING_LENGTH	60

#define RF_LEVEL_LIMIT_1GHZ	1000000000	 // 30Hz ~ 999999999Hz : +7dBm, 1000000000Hz ~ 2500000000 Hz : +3dBm
// Error Code Definitions
enum VTS_Return_e
{
	VTS_SUCCESS = 0,
	VTS_WARNING = 0x10000,
	VTS_ERROR = 0x11000,
	VTS_ERROR_UNSUPPORT,
	VTS_ERROR_INVALID_PARAM,

	VTS_ERROR_COMM_FAIL,
	VTS_ERROR_TIME_OUT,
	VTS_ERROR_UNKNOWN_CMD,
	VTS_ERROR_INVALID_HANDLE,
	VTS_ERROR_DEVICE_NOT_FOUND,
	VTS_ERROR_DEVIOCTRL_FAIL,
	VTS_ERROR_DEVICE_NOT_OPEN,
	VTS_ERROR_DEVICE_DETAIL_NULL,
	VTS_ERROR_DEVICE_INFO_NULL,
	VTS_ERROR_DEVICE_CLOSE_HANDLE,
	VTS_ERROR_EEPROM_READ_STATUS_OVER_COUNT,

	VTS_ERROR_ATTEN_NOT_ATTACHED,
	VTS_ERROR_UP_CONV_ATTEN_NOT_ATTACHED,
	VTS_ERROR_SKYBAND,
	VTS_ERROR_SKYBAND_NOT_ATTACHED,
	
	VTS_ERROR_ETI_SYNC_NOT_FOUND,
	
	VTS_ERROR_ISDBT_SYNC_NOT_FOUND,
	
	VTS_ERROR_WRONG_BC_TYPE,
	VTS_ERROR_UNSUPPORTED_IF,
	VTS_ERROR_UNSUPPORTED_UF1,
	VTS_ERROR_TS_SYNC_CHECK,

	VTS_ERROR_CMMB_CLCH_INVALID_SCRAMBLE = 0x100000,
	VTS_ERROR_CMMB_SYNC_NOT_FOUND,
	VTS_ERROR_CMMB_EXCEED_BIT_RATE,
	VTS_ERROR_CMMB_DELETE_FAIL,
	VTS_ERROR_CMMB_NOCMMB_FILE_ADDED,
	VTS_ERROR_CMMB_MMFS_FILE_ADDED,
	VTS_ERROR_CMMB_INVALID_TIMESLOTSIZE,
	VTS_ERROR_CMMB_EXCEED_TIME_SLOT,
	VTS_ERROR_CMMB_SINGLE_MFS,
	VTS_CMMB_FILE_TYPE_ESG,
	VTS_ERROR_CMMB_NONCORRESPONDING_CLCH,

	VTS_DTMB_SUCCESS = 0x110000,
	VTS_DTMB_ERROR,
	VTS_DTMB_FAIL_TO_OPEN,
	VTS_DTMB_FAIL_TO_OPEN_TOO_SMALL_SIZE,
	VTS_DTMB_FAIL_TO_FIND_TS_SYNC,
	VTS_DTMB_FAIL_TO_PARSING_PMT,
	VTS_DTMB_FAIL_TO_PARSING_PAT,		                
	            
	VTS_ATSC_MH_ERROR_UNKNOWN = 0x120000,                 
	VTS_ATSC_MH_ERROR_FILE_ACCESS,             
	VTS_ATSC_MH_ERROR_FILE_END,	
	VTS_ATSC_MH_ERROR_RS_FULL,	
	VTS_ATSC_MH_ERROR_IP_HEADER,	            
	VTS_ATSC_MH_ERROR_IP_HEADER_VERSION,        
	VTS_ATSC_MH_ERROR_IP_HEADER_VARIABLE_IP,    
	VTS_ATSC_MH_ERROR_IP_HEADER_NOTUSE_UDP,		
	VTS_ATSC_MH_ERROR_UDP_HEADER_MAXNUM,		
	VTS_ATSC_MH_ERROR_UDP_HEADER_CHECKSUM,	
	VTS_ATSC_MH_ERROR_FILE_MODE_NEED_RELOAD,			
	VTS_ATSC_MH_ERROR_FILE_MODE_NEED_CHANGE_ENSEMBLEMODE,	
	VTS_ATSC_MH_ERROR_FILE_MODE_NEED_CHANGE_SERVICEMODE,		
	VTS_ATSC_MH_ERROR_FILE_SAME_FILE_USING,	
	VTS_ATSC_MH_ERROR_EN_ENSEMBLE_NOTDEFINE,		
	VTS_ATSC_MH_ERROR_EN_ENSEMBLE_NOTVARIABLE,		
	VTS_ATSC_MH_ERROR_EN_SERVICE_ID_SAME,			
	VTS_ATSC_MH_ERROR_EN_SERVICE_ID_RANGE,			
	VTS_ATSC_MH_ERROR_EN_SAME_SERVICE_IP,			
	VTS_ATSC_MH_ERROR_ENCD_COMPONENT_DESCR_LEN_MISMATCH,		
	VTS_ATSC_MH_ERROR_PR_NOG_OVERFLOW_PRIMARY,		
	VTS_ATSC_MH_ERROR_PR_NOG_OVERFLOW_SECONDARY,	
	VTS_ATSC_MH_ERROR_PR_NOG_LOWER_MIN,			
	VTS_ATSC_MH_ERROR_PR_TNOG_OVERFLOW,			
	VTS_ATSC_MH_ERROR_PR_ENSEMBLE_SAMEUSE,			
	VTS_ATSC_MH_ERROR_PR_PARADEID_SAMEUSE,			
	VTS_ATSC_MH_ERROR_PR_RSFRAMEMODE_DUAL,		
	VTS_ATSC_MH_ERROR_ST_PARADENOTUSE,			
	VTS_ATSC_MH_ERROR_INITIALIZE_FAILED,
	
	VTS_ATSC_MH_ERROR_MAIN_TS_BITRATE_OVERFLOW,
	VTS_ATSC_MH_ERROR_MAIN_TS_NOT_PRESENT,

	VTS_ATSC_MH_MAIN_TS,
	VTS_ATSC_MH_MH_TS,
	VTS_ATSC_MH_UNKNOWN_TS,

	VTS_ATSC_MH_SSC_FLAG,

	////////////////////////////////
	//T-DMB MUX ADDED BY KSJ - START
	//ETI NI error part
	VTS_TDMB_ERROR_DAB_PART = 0x130000,
	//ETI FILE Add
	VTS_TDMB_ERROR_FILE_SAME,
	VTS_TDMB_ERROR_FILE_MAX,
	VTS_TDMB_ERROR_SERVICE_MAX,
	VTS_TDMB_ERROR_SUBCH_MAX,

	//ETI NI error part
	VTS_TDMB_ERROR_ETI_NI_UNKNOWN,
	VTS_TDMB_ERROR_ETI_NI_FSYNC,
	VTS_TDMB_ERROR_ETI_NI_FC,
	VTS_TDMB_ERROR_ETI_NI_STC,
	VTS_TDMB_ERROR_ETI_NI_CRC,
	//ETI File Manager Error
	VTS_TDMB_ERROR_ETI_FILE_UNKNOWN,
	VTS_TDMB_ERROR_ETI_FILE_CONTROL,
	VTS_TDMB_ERROR_ETI_FILE_RECONFIG,
	VTS_TDMB_ERROR_ETI_FILE_END,
	//FIB Parser 
	VTS_TDMB_ERROR_FIB_UNKNOWN,
	//Check Data
	VTS_TDMB_ERROR_CHECK_SERVICEID,
	VTS_TDMB_ERROR_CHECK_SERVICECOMPONENTID,
	VTS_TDMB_ERROR_CHECK_CUOVERFLOW,
	VTS_TDMB_ERROR_CHECK_SUBCHID,
	//T-DMB MUX ADDED BY KSJ - END
	////////////////////////////////

	VTS_DVBS2_END_OF_FILE = 0x140000,
	VTS_DVBT2_ERROR_FAIL_OPEN,			//Call "DVBT2_GetError"
	VTS_DVBT2_FAIL_TO_SET_PARAM,		//Call "DVBT2_GetError"	
	VTS_TUNER_ERR_BASE = 0x160000,
	VTS_TUNER_ERR_I2C = VTS_TUNER_ERR_BASE + 1,
	VTS_TUNER_ERR_INIT = VTS_TUNER_ERR_BASE + 2,
	VTS_TUNER_ERR_RUN = VTS_TUNER_ERR_BASE + 4,
	VTS_TUNER_ERR_PARAM = VTS_TUNER_ERR_BASE + 8,
	VTS_TUNER_ERR_CHECK_FUNC = VTS_TUNER_ERR_BASE + 16,
	VTS_TUNER_ERR_ALTER_FUNC = VTS_TUNER_ERR_BASE + 32,
	VTS_TUNER_ERR_SCAN = VTS_TUNER_ERR_BASE + 64,
	VTS_TUNER_ERR_ANT = VTS_TUNER_ERR_BASE + 128,
	VTS_TUNER_ERR_TUNER = VTS_TUNER_ERR_BASE + 256,
	VTS_TUNER_ERR_OTHER = VTS_TUNER_ERR_BASE + 512,
	VTS_TUNER_FREQ_ERR,
	VTS_TUNER_POWER_DETECT_ERROR,
};

typedef unsigned int VTS_Return_t;

typedef union VTS_ModulatorID_u
{
	struct {
		unsigned short	bf4_VersionMinor	:4; // 0
		unsigned short	bf4_VersionMajor	:4; // 1
		unsigned short	bf4_Preamble		:4; // 5
		unsigned short	bf4_ID				:4; // BroadcastType
	};
	unsigned short u2_Value;
} VTS_ModulatorID_t;

typedef union VTS_PumpID_u
{
	struct {
		unsigned int	bf8_VersionMinor	:8;
		unsigned int	bf8_VersionMajor	:8;
		unsigned int	bf16_ID				:16;
	};
	unsigned int u4_Value;
} VTS_PumpID_t;

enum VTS_PUMP_ID_e
{
	VTS_PUMP_ID_VENTUS_10	= 0x0001,	// Ventus 1.0
	VTS_PUMP_ID_VENTUS_20	= 0x0002,	// Ventus 2.0
	VTS_PUMP_ID_VENTUS_25	= 0x0003,	// Ventus 2.5
	VTS_PUMP_ID_VENTUS_Q	= 0x0004,	// Ventus Q
	VTS_PUMP_ID_VENTUS_A	= 0x0006,	// Ventus A (ASI In-Out), Ventus A+(ASI/SMPTE In-Out, RF In)
	VTS_PUMP_ID_VENTUS_A_PLUS_US	= 0x0007,	// Ventus A + Tuner(US)
	VTS_PUMP_ID_VENTUS_A_PLUS_EU	= 0x0008,	// Ventus A + Tuner(EU)
};

typedef enum VTS_TunerID_e
{
	VTS_TUNER_ID_NONE,		// 
	VTS_TUNER_ID_H011F,		// H011F, LG
	VTS_TUNER_ID_SI2177,
	VTS_TUNER_ID_MAX
}VTS_TunerID_t;

typedef enum VTS_DemodID_e
{
	VTS_DEMOD_ID_NONE,		// 
	VTS_DEMOD_ID_LGDT3305,	// LGDT3305, VSB & OpenCable
	VTS_DEMOD_ID_SI2164,		// DVB-C/C2, DVB-T/T2
	VTS_DEMOD_ID_MAX
}VTS_DemodID_t;

typedef enum VTS_TunerStandard_e
{
	VTS_TUNER_STD_NONE,
	VTS_TUNER_STD_8VSB,
	VTS_TUNER_STD_64QAM,
	VTS_TUNER_STD_256QAM,
	VTS_TUNER_STD_NTSC,
}VTS_TunerStandard_t;

typedef union VTS_AttenuatorID_u
{
	struct {
		unsigned int	bf8_VersionMinor	:8;
		unsigned int	bf8_VersionMajor	:8;
		unsigned int	bf8_VersionHw		:8;
		unsigned int	bf8_ID				:8;
	};
	unsigned int u4_Value;
} VTS_AttenuatorID_t;

typedef union VTS_SkyBandID_u //for SkyBand
{
	struct {
		unsigned int	bf8_VersionMinor	:8;
		unsigned int	bf8_VersionMajor	:8;
		unsigned int	bf8_VersionHw		:8;
		unsigned int	bf8_ID				:8;
	};
	unsigned int u4_Value;
} VTS_SkyBandID_t;

typedef union VTS_UpConverterID_u
{
	struct {
		unsigned int	bf8_VersionMinor	:8;
		unsigned int	bf8_VersionMajor	:8;
		unsigned int	bf8_VersionHw		:8;
		unsigned int	bf8_ID				:8;
	};
	unsigned int u4_Value;
} VTS_UpConverterID_t;

typedef union VTS_ApiVersion_u
{
	struct {
		unsigned int	bf16_Build			:16;
		unsigned int	bf8_VersionMinor	:8;
		unsigned int	bf8_VersionMajor	:8;
	};
	unsigned int u4_Value;
} VTS_ApiVersion_t;

typedef enum VTS_PumpMode_e
{
	VTS_PUMP_MODE_ASI_OUT		= 0,
	VTS_PUMP_MODE_RF_OUT		= 1, // for DVB-x, ATSC, CW,...
	VTS_PUMP_MODE_ASI_IN		= 2,
	VTS_PUMP_MODE_ASI_RF		= 3, // ASI-IN to RF-OUT
	VTS_PUMP_MODE_RF_OUT_RAW	= 6, // for T-DMB, ISDB-T, CMMB...
} VTS_PumpMode_t;

typedef enum VTS_TS_Format_e
{
	VTS_TS_FORMAT_188 = 0,
	VTS_TS_FORMAT_204 = 1,
	VTS_TS_FORMAT_UNKNOWN 
	//VTS_TS_FORMAT_RAW = 2,
	//VTS_TS_FORMAT_UNKNOWN = 3
} VTS_TS_Format_t;

typedef enum VTS_PumpState_e
{
	VTS_PUMP_STATE_STOP		= 0, //Pause
	VTS_PUMP_STATE_STOP_CLR	= 1, //Stop
	VTS_PUMP_STATE_RUN		= 2  //Play
} VTS_PumpState_t;

typedef union VTS_DriverVersion_u
{
	struct {
		unsigned int	bf8_Day				:8;
		unsigned int	bf8_Month			:8;
		unsigned int	bf8_Year			:8;
		unsigned int	bf8_VersionMajor	:8;
	};
	unsigned int u4_Value;
} VTS_DriverVersion_t;

typedef enum VTS_BroadcastType_e
{
	VTS_BC_NULL		= 0x00,
	VTS_BC_CW			= 0x01,
	VTS_BC_DVB_S		= 0x02,
	VTS_BC_DVB_S2		= 0x03,
	VTS_BC_DVB_T		= 0x04,
	VTS_BC_DVB_H		= 0x05,
	VTS_BC_DVB_C		= 0x06,
	VTS_BC_ATSC		= 0x07,
	VTS_BC_QAM_B		= 0x08,
	VTS_BC_QAM_C		= 0x09,
	VTS_BC_ISDB_T		= 0x0A,
	VTS_BC_T_DMB		= 0x0B,
	VTS_BC_DTMB		= 0x0C,
	VTS_BC_CMMB		= 0x0D,
	VTS_BC_ATSC_MH		= 0x0E,
	VTS_BC_CMMB_NON_MULTIPLEX = 0x0F,
	VTS_BC_DVB_T2		= 0x10,
	VTS_BC_ANALOG_FM	= 0x11,
	VTS_BC_HDRADIO		= 0x12,
	VTS_BC_MAX			= 0x13
} VTS_BroadcastType_t;

typedef enum VTS_OtType_e
{
	VTS_OT_AWGN					= 0x1000,
	VTS_OT_ATSC_MH_MUX			= 0x1001,
	VTS_OT_DMB_MUX 				= 0x1002,
	VTS2_OT_FREQ_2500MHZ_MAX 	= 0x1003,
	VTS2_OT_FREQ_30MHZ_MIN 		= 0x1004,
	VTS_OT_MAX
} VTS_OtType_t;


// Modulation Parameters ///////////////////////////////////////////////////////
typedef enum VTS_DVB_S_Constel_e
{
	VTS_DVB_S_CONSTELL_QPSK,
	//VTS_DVB_S_CONSTELL_8PSK, //Only QPSK
	//VTS_DVB_S_CONSTELL_16QAM, //Only QPSK
} VTS_DVB_S_Constel_t;
typedef enum VTS_DVB_S_CodeRate_e
{
	VTS_DVB_S_CODE_RATE_1_2,
	VTS_DVB_S_CODE_RATE_2_3,
	VTS_DVB_S_CODE_RATE_3_4,
	VTS_DVB_S_CODE_RATE_5_6,
	VTS_DVB_S_CODE_RATE_7_8
} VTS_DVB_S_CodeRate_t;
typedef enum VTS_DVB_S2_Constel_e
{
	VTS_DVB_S2_CONSTELL_QPSK,
	VTS_DVB_S2_CONSTELL_8PSK,
	//VTS_DVB_S2_CONSTELL_16APSK,	//Not supported
	//VTS_DVB_S2_CONSTELL_32APSK	//Not supported
} VTS_DVB_S2_Constel_t;

typedef enum VTS_DVB_S2_CodeRate_e
{
	VTS_DVB_S2_CODE_RATE_1_4,
	VTS_DVB_S2_CODE_RATE_1_3,
	VTS_DVB_S2_CODE_RATE_2_5,
	VTS_DVB_S2_CODE_RATE_1_2,
	VTS_DVB_S2_CODE_RATE_3_5,
	VTS_DVB_S2_CODE_RATE_2_3,
	VTS_DVB_S2_CODE_RATE_3_4,
	VTS_DVB_S2_CODE_RATE_4_5,
	VTS_DVB_S2_CODE_RATE_5_6,
	VTS_DVB_S2_CODE_RATE_8_9,
	VTS_DVB_S2_CODE_RATE_9_10
} VTS_DVB_S2_CodeRate_t;

typedef enum VTS_DVB_S2_Alpha_e
{
	VTS_DVB_S2_ALPHA_35,
	VTS_DVB_S2_ALPHA_25,
	VTS_DVB_S2_ALPHA_20	
} VTS_DVB_S2_Alpha_t;

typedef enum VTS_ISDB_T_GuardInt_e
{
	VTS_ISDB_T_GUARD_INT_1_32,
	VTS_ISDB_T_GUARD_INT_1_16,
	VTS_ISDB_T_GUARD_INT_1_8,
	VTS_ISDB_T_GUARD_INT_1_4
} VTS_ISDB_T_GuardInt_t;

typedef enum VTS_ISDB_T_TxMode_e
{
	VTS_ISDB_T_TRANS_MODE_1, // 2K
	VTS_ISDB_T_TRANS_MODE_3, //8K
	VTS_ISDB_T_TRANS_MODE_2 // 4K
} VTS_ISDB_T_TxMode_t;
typedef enum VTS_ISDB_T_Constel_e
{
	VTS_ISDB_T_CONSTELL_QPSK,
	VTS_ISDB_T_CONSTELL_16QAM,
	VTS_ISDB_T_CONSTELL_64QAM
} VTS_ISDB_T_Constel_t;
typedef enum VTS_ISDB_T_CodeRate_e
{
	VTS_ISDB_T_CODE_RATE_1_2,
	VTS_ISDB_T_CODE_RATE_2_3,
	VTS_ISDB_T_CODE_RATE_3_4,
	VTS_ISDB_T_CODE_RATE_5_6,
	VTS_ISDB_T_CODE_RATE_7_8
} VTS_ISDB_T_CodeRate_t;
typedef enum VTS_ISDB_T_TimeIntlvLength_e
{
	VTS_ISDB_T_TIME_INTLV_0,
	VTS_ISDB_T_TIME_INTLV_1,
	VTS_ISDB_T_TIME_INTLV_2,
	VTS_ISDB_T_TIME_INTLV_4,
	VTS_ISDB_T_TIME_INTLV_8,
	VTS_ISDB_T_TIME_INTLV_16,
} VTS_ISDB_T_TimeIntlvLength_t;
typedef enum VTS_ISDB_T_Layer_e
{
	VTS_ISDB_T_Layer_A,
	VTS_ISDB_T_Layer_B,
	VTS_ISDB_T_Layer_C,
} VTS_ISDB_T_Layer_t;
typedef struct _ISDB_Layer_Parameter_t
{
	unsigned char mu1_Modulation; //constellation
	unsigned char mu1_CodeRate;
	unsigned char mu1_TimeIntrlLength;
	unsigned char mu1_segment;
}ISDB_Layer_Parameter_t;

typedef struct _ISDB_OfdmConfig_t
{
	unsigned char mu1_Mode;	//IFFT
	unsigned char mu1_GuardInterval;
	unsigned short mu2_FFT_size;
	unsigned short mu2_GuardBand;	
	unsigned short mu2_data_in_1seg;
	unsigned short mu2_carrier_in_1seg;
	unsigned short mu2_Remux_TSP;
}ISDB_OfdmConfig_t;

typedef enum VTS_DVB_TH_Constel_e
{
	VTS_DVB_TH_CONSTELL_QPSK,
	VTS_DVB_TH_CONSTELL_16QAM,
	VTS_DVB_TH_CONSTELL_64QAM
} VTS_DVB_TH_Constel_t;

typedef enum VTS_DVB_TH_CodeRate_e
{
	VTS_DVB_TH_CODE_RATE_1_2,
	VTS_DVB_TH_CODE_RATE_2_3,
	VTS_DVB_TH_CODE_RATE_3_4,
	VTS_DVB_TH_CODE_RATE_5_6,
	VTS_DVB_TH_CODE_RATE_7_8
} VTS_DVB_TH_CodeRate_t;

typedef enum VTS_DVB_TH_GuardInt_e
{
	VTS_DVB_TH_GUARD_INT_1_32,
	VTS_DVB_TH_GUARD_INT_1_16,
	VTS_DVB_TH_GUARD_INT_1_8,
	VTS_DVB_TH_GUARD_INT_1_4
} VTS_DVB_TH_GuardInt_t;

typedef enum VTS_DVB_TH_TxMode_e
{
	VTS_DVB_TH_TRANS_MODE_2K,
	VTS_DVB_TH_TRANS_MODE_8K,
	VTS_DVB_TH_TRANS_MODE_4K
} VTS_DVB_TH_TxMode_t;

typedef enum VTS_DVB_TH_Hierarchy_e
{
	VTS_DVB_TH_HIERARCHY_NON,
	VTS_DVB_TH_HIERARCHY_1,
	VTS_DVB_TH_HIERARCHY_2,
	VTS_DVB_TH_HIERARCHY_4
} VTS_DVB_TH_Hierarchy_t;

typedef enum VTS_DVB_TH_Interleaver_e
{
	VTS_DVB_TH_INTERLEAVER_NATIVE,
	VTS_DVB_TH_INTERLEAVER_IN_DEPTH
} VTS_DVB_TH_Interleaver_t;

typedef enum VTS_DVB_C_Constel_e
{
	VTS_DVB_C_QAM16,
	VTS_DVB_C_QAM32,
	VTS_DVB_C_QAM64,
	VTS_DVB_C_QAM128,
	VTS_DVB_C_QAM256
} VTS_DVB_C_Constel_t;

typedef enum VTS_QAM_B_Constel_e
{
	VTS_QAM_B_QAM64		= VTS_DVB_C_QAM64,
	VTS_QAM_B_QAM256	= VTS_DVB_C_QAM256
} VTS_QAM_B_Constel_t;

typedef enum VTS_QAM_B_Interleaving_e
{
	VTS_QAM_B_I64_J2	= 0x3,
	VTS_QAM_B_I32_J4	= 0x5,
	VTS_QAM_B_I16_J8	= 0x7,
	VTS_QAM_B_I8_J16	= 0x9,
	VTS_QAM_B_I128_J1	= 0x1,
	VTS_QAM_B_I128_J2	= 0x2,
	VTS_QAM_B_I128_J3	= 0x4,
	VTS_QAM_B_I128_J4	= 0x6,
	VTS_QAM_B_I128_J5	= 0x8,
	VTS_QAM_B_I128_J6	= 0xA,
	VTS_QAM_B_I128_J7	= 0xC,
	VTS_QAM_B_I128_J8	= 0xE

} VTS_QAM_B_Interleaving_t;

typedef enum _CmmbRs_e
{
	CMMB_RS_240,
	CMMB_RS_224,
	CMMB_RS_192,
	CMMB_RS_176
}CmmbRs_t;
typedef enum _CmmbLdpc_e
{
	CMMB_LDPC_1_2,
	CMMB_LDPC_3_4,	
}CmmbLdpc_t;

typedef enum _CmmbModulation_e
{
	CMMB_QNST_BPSK,
	CMMB_QNST_QPSK,
	CMMB_QNST_16QAM,	
}CmmbModulation_t;

typedef enum _CmmbScramble_e
{
	CMMB_SCR_MOD0,
	CMMB_SCR_MOD1,
	CMMB_SCR_MOD2,
	CMMB_SCR_MOD3,
	CMMB_SCR_MOD4,
	CMMB_SCR_MOD5,
	CMMB_SCR_MOD6,
	CMMB_SCR_MOD7	
}CmmbScramble_t;

typedef enum _CmmbBW_e
{
	CMMB_8MH,
	CMMB_2MH
}CmmbBW_t;

typedef enum _CmmbIntrlMode_e
{
	CMMB_INTRL_MOD1 = 1,
	CMMB_INTRL_MOD2,
	CMMB_INTRL_MOD3
}CmmbIntrlMode_t;

typedef enum _CmmbServiceType_t
{
	CMMB_SERVICE_TYPE_DEFAULT,
	CMMB_SERVICE_TYPE_VIDEO,
	CMMB_SERVICE_TYPE_AUDIO,
	CMMB_SERVICE_TYPE_DATA,
	CMMB_SERVICE_TYPE_ESG,
	CMMB_SERVICE_TYPE_EMM
}CmmbServiceType_t;

typedef enum _CmmbVideoFormat_e
{	
	CMMB_VIDEO_TYPE_AVS,
	CMMB_VIDEO_TYPE_H_264,
	CMMB_VIDEO_TYPE_RESERVED
}CmmbVideoFormat_t;

typedef enum _CmmbAudioFormat_e
{	
	CMMB_AUDIO_TYPE_DRA,
	CMMB_AUDIO_TYEP_HE_AAC,
	CMMB_AUDIO_TYEP_ACC,
	CMMB_AUDIO_TYPE_RESERVED
}CmmbAudioFormat_t;

typedef struct _CmmbClchCheck_t
{
	bool b_RsCheck;
	bool b_LdpcCheck;
	bool b_ConstCheck;
	bool b_ScrambleCheck;
	bool b_TimeSlotCheck;
}CmmbClchCheck_t;

typedef struct _CmmbSourceBps_u
{
	unsigned int		mu4_Video;
	unsigned int		mu4_Audio;
	unsigned int		mu4_Data;
	unsigned int		mu4_Total;
}CmmbSourceBps_t;

typedef struct _CmmbInformation_t
{	
	CmmbRs_t			mt_Rs;
	CmmbScramble_t		mt_Scramble;
	CmmbModulation_t	mt_Modulation;
	CmmbLdpc_t			mt_Lpdc;	
	CmmbBW_t			mt_BandWidth;
	CmmbIntrlMode_t		mt_IntrlMod;
	unsigned char		mu1_TimeSlotN;
}CmmbInformation_t;

typedef enum _Cmmb_CAType_t
{
	CMMB_CA_ClearToAir,
	CMMB_CA_Decrypt,
	CMMB_CA_Encrypt,
	CMMB_CA_RESERVED
}Cmmb_CAType_t;

typedef struct _CmmbFrame_t
{	
	CmmbInformation_t	mt_Parameter;
	unsigned char		mu1_MF_ID;
	int					ms4_MaxDataSize;	
	CmmbSourceBps_t		mt_SourceBps;					//Frame bps(= bit per second)
	unsigned int		mu4_OutBitrate;					//Frame Out Bit rate(=bit per second)
	int					ms4_FileFrameSize;				//the size read by stream for each LCH
	int					ms4_Offset;						//offset for single channel stream
	unsigned char		mu1_SubFrameN;
	bool				mb_IsNewVersion;
	unsigned char		ma_AvailableTslotN[39];
	CmmbServiceType_t	mt_ServiceType;
	CmmbAudioFormat_t	mt_AudioFormat;
	CmmbVideoFormat_t	mt_VideoFormat;
	unsigned char				mu1a_ServiceId[2];
	bool									mb_IsFramePadding;
	Cmmb_CAType_t			mt_CAtype;
}CmmbFrame_t;

typedef struct _CmmbConfig_t
{
	CmmbFrame_t		mt_Lch[40];	
	int				ms4_FrameN;
	int				ms4_Offset;				//offset for multi channel stream
	int				ms4_FrameSize;			//Whole frame size of the multi channel stream
	bool			mb_IsTs;
	bool			mb_Is0xFFpadding;
}CmmbConfig_t;

// typedef enum _CmmbChangeParameter_t
// {
// 	CMMB_MODULATION,
// 	CMMB_LDPC,
// 	CMMB_RS,
// 	CMMB_SCRAMBLE,
// 	CMMB_INTRLMODE,
// 	CMMB_TIMESLOT_N,
// 	CMMB_BANDWIDTH
// }CmmbChangeParameter_t;

////////////////////////////////////////////////////////////////////////////////
typedef enum _VTS_DTMB_PnMode_e
{
	DTMB_PN_420,
	DTMB_PN_595,
	DTMB_PN_945,	
	DTMB_PN_MAX
}VTS_DTMB_PnMode_e;

typedef enum VTS_DTMB_Carrier_e
{
	VTS_DTMB_CARRIER_1,
	VTS_DTMB_CARRIER_3780,
	VTS_DTMB_CARRIER_MAX
} VTS_DTMB_Carrier_t;

typedef enum _VTS_DTMB_Mapping_e
{
	DTMB_CONST_4QAM_NR,
	DTMB_CONST_4QAM,	
	DTMB_CONST_16QAM,
	DTMB_CONST_32QAM,
	DTMB_CONST_64QAM,
	DTMB_CONST_MAX
}VTS_DTMB_Mapping_e;

typedef enum _VTS_DTMB_LDPC_e
{
	DTMB_LDPC_04,
	DTMB_LDPC_06,
	DTMB_LDPC_08,
	DTMB_LDPC_MAX
}VTS_DTMB_LDPC_e;

typedef enum _VTS_DTMB_IntrlMode_e
{
	DTMB_INTRL_MODE_1,
	DTMB_INTRL_MODE_2,
	DTMB_INTRL_MODE_MAX
}VTS_DTMB_IntrlMode_e;

typedef enum VTS_DTMB_PilotFrequency_e //only available at Multi
{
	VTS_DTMB_PILOT_FREQUENCY_OFF,
	VTS_DTMB_PILOT_FREQUENCY_ON,		
	VTS_DTMB_PILOT_FREQUENCY_MAX
} VTS_DTMB_PilotFrequency_t;

typedef enum VTS_DTMB_PN_Phase_e
{
	VTS_DTMB_PN_PHASE_VARIOUS,
	VTS_DTMB_PN_PHASE_CONSTANT,
	VTS_DTMB_PN_PHASE_MAX
} VTS_DTMB_PN_Phase_t;

typedef struct _t_VTS_DTMB_CONFIG
{
	VTS_DTMB_PnMode_e t_PnMode;
	VTS_DTMB_Carrier_t t_Carrier; 
	VTS_DTMB_Mapping_e t_Mapping; 
	VTS_DTMB_LDPC_e t_LdpcRate; 
	VTS_DTMB_IntrlMode_e t_IntrlMode; 
	VTS_DTMB_PilotFrequency_t t_PilotFrequency; 
	VTS_DTMB_PN_Phase_t t_PNPhase;
}VTS_DTMB_CONFIG_t;

typedef enum _DVBT2_FFT_SIZE_e
{
	DVBT2_FFT_SIZE_1K = 1,
	DVBT2_FFT_SIZE_2K = 2,
	DVBT2_FFT_SIZE_4K = 4,
	DVBT2_FFT_SIZE_8K = 8,
	DVBT2_FFT_SIZE_16K = 16,
	DVBT2_FFT_SIZE_32K = 32,	
}VTS_DVBT2_FFT_SIZE_e;

typedef enum _DVBT2_GI_e
{
	DVBT2_GI_1_32,		//000
	DVBT2_GI_1_16,		//001
	DVBT2_GI_1_8,		//010
	DVBT2_GI_1_4,		//011
	DVBT2_GI_1_128,	//100
	DVBT2_GI_19_128,	//101
	DVBT2_GI_19_256	//110
}VTS_DVBT2_GI_e;

typedef enum _DVBT2_PP_e
{
	DVBT2_PP_1,
	DVBT2_PP_2,
	DVBT2_PP_3,
	DVBT2_PP_4,
	DVBT2_PP_5,
	DVBT2_PP_6,
	DVBT2_PP_7,
	DVBT2_PP_8	
}VTS_DVBT2_PP_e;

typedef enum _DVBT2_BW_e
{
	DVBT2_BW_1_7_MHZ,
	DVBT2_BW_5_MHZ,
	DVBT2_BW_6_MHZ,
	DVBT2_BW_7_MHZ,
	DVBT2_BW_8_MHZ,
	DVBT2_BW_10_MHZ
}VTS_DVBT2_BW_e;

typedef enum _DVBT2_VERSION_e
{
	DVBT2_VERSION_1_1_1,
	DVBT2_VERSION_1_2_1
}VTS_DVBT2_VERSION_e;

typedef enum _DVBT2_L1PostMod_e
{	
	DVBT2_L1POSTMOD_BPSK,
	DVBT2_L1POSTMOD_QPSK,
	DVBT2_L1POSTMOD_16QAM,
	DVBT2_L1POSTMOD_64QAM	
}VTS_DVBT2_L1POSTMOD_e;

typedef enum _VTS_DVBT2_LDPC_e
{
	DVBT2_LDPC_1_2,
	DVBT2_LDPC_3_5,
	DVBT2_LDPC_2_3,
	DVBT2_LDPC_3_4,
	DVBT2_LDPC_4_5,
	DVBT2_LDPC_5_6,
	DVBT2_LDPC_1_4
}VTS_DVBT2_LDPC_e;

typedef enum _DVBT2_PLP_MAPPING_e
{
	DVBT2_PLP_MAPPING_QPSK,
	DVBT2_PLP_MAPPING_16QAM,
	DVBT2_PLP_MAPPING_64QAM,
	DVBT2_PLP_MAPPING_256QAM,
}VTS_DVBT2_PLP_MAPPING_e;

typedef enum _DVBT2_FECTYPE_e
{
	DVBT2_FECTYPE_16K,
	DVBT2_FECTYPE_64K
}VTS_DVBT2_FECTYPE_e;

typedef enum _DVBT2_PlpType_e
{
	DVBT2_PlpType_COMMON,
	DVBT2_PlpType_DATA1,
	DVBT2_PlpType_DATA2
}VTS_DVBT2_PlpType_e;

typedef struct _DVBT2_PLP_Infor
{
	VTS_DVBT2_LDPC_e	e_Ldpc;
	VTS_DVBT2_PLP_MAPPING_e	e_Mapping;
	VTS_DVBT2_FECTYPE_e	e_FecType;
	VTS_DVBT2_PlpType_e	e_PlpType;
	int s4_TimeIntrlType;
	int s4_TimeIntrlLength;
	int s4_FrameInterval;
	int s4_FirstFrameIndex;
	int s4_BlocksN;
	bool b_Rotation;
	bool b_InBandA;
}VTS_DVBT2_PLP_Infor_t;

typedef struct _DVBT2_SYSTEM_Infor
{	
	VTS_DVBT2_FFT_SIZE_e e_FftSize;
	VTS_DVBT2_GI_e e_GuardInterval;
	VTS_DVBT2_BW_e e_BandWidth;
	VTS_DVBT2_L1POSTMOD_e e_L1PostMod;
	VTS_DVBT2_PP_e e_Pp;
	int s4_T2FramesN;
	int s4_DataSymbolsN;
	VTS_DVBT2_VERSION_e e_Version;
	int s4_SubSlicesN;
	bool b_L1Repetition;
	bool b_BwtExt;
	int s4_DvbT2PlpN;
	int s4_T2SystemId;
	int s4_NetworkId;
	int s4_CellId;
	//Read Only
	int s4_MaxSymbolsN;
	int s4_TotalCellsN;
	int s4_L1CellsN;
	int s4_DummyCellsN;	
	bool b_Fc;		//true : frame closing symbol exist, false : don't exist
}VTS_DVBT2_SYSTEM_Infor_t;
typedef enum _VTS_HDRADIO_MODULATION 
{
	HDRADIO_FM, // In hdradio, there is also AM, but Ventus platform is not support AM. because of freq. range.
	HDRADIO_MODULATION_TOP
}VTS_HDRADIO_MODULATION_e;

typedef enum _VTS_HDRADIO_AM_FREQ
{
	HDRADIO_AM_530KHZ,
	HDRADIO_AM_820KHZ,
	HDRADIO_AM_1120KHZ,
	HDRADIO_AM_1420KHZ,
	HDRADIO_AM_1710KHZ,
	HDRADIO_AM_FREQ_TOP
}VTS_HDRADIO_AM_FREQ_e;

typedef enum _VTS_HDRADIO_FM_FREQ
{	 
	HDRADIO_FM_87_9MHZ,
	HDRADIO_FM_92_9MHZ,
	HDRADIO_FM_97_9MHZ,
	HDRADIO_FM_102_9MHZ,
	HDRADIO_FM_107_9MHZ,
	HDRADIO_FM_FREQ_TOP
}VTS_HDRADIO_FM_FREQ_e;

typedef enum _VTS_HDRADIO_FREQ_UNIT_AM
{		
	HDRADIO_UNIT_AM_KHZ,	
	HDRADIO_UNIT_AM_TOP
}VTS_HDRADIO_FREQ_UNIT_AM_e;

typedef enum _VTS_HDRADIO_FREQ_UNIT_FM
{	
	HDRADIO_UNIT_FM_MHZ,
	HDRADIO_UNIT_FM_TOP
}VTS_HDRADIO_FREQ_UNIT_FM_e;

typedef enum _VTS_HDRADIO_FREQ_UNIT
{	 
	HDRADIO_UNIT_HZ,
	HDRADIO_UNIT_KHZ,
	HDRADIO_UNIT_MHZ,
	HDRADIO_UNIT_TOP
}VTS_HDRADIO_FREQ_UNIT_e;

typedef enum _VTS_HDRADIO_DIF_UNIT
{
	HDRADIO_UNIT_DIF_PPM,
	HDRADIO_UNIT_DIF_HZ,
	HDRADIO_UNIT_DIF_KHZ,
	HDRADIO_UNIT_DIF_TOP
}VTS_HDRADIO_DIF_UNIT_e;

typedef struct _HDRADIO_SYSTEM_INFO
{
	BOOL b_FreqFm;
	BOOL b_Res;
	VTS_HDRADIO_MODULATION_e e_Modulation;	
	VTS_HDRADIO_FM_FREQ_e e_FreqFm;	
	VTS_HDRADIO_FREQ_UNIT_FM_e e_UnitFreqFM;
	VTS_HDRADIO_FREQ_UNIT_e e_UnitOri;
	DOUBLE d_ResSampleRate_Hz; // result sample rate - effective sample rate
	VTS_HDRADIO_FREQ_UNIT_e e_UnitRes;
	DOUBLE d_DifVar_PPM; // Diffence of the sample rate between Result and Original rate.
	VTS_HDRADIO_DIF_UNIT_e e_UnitDif;
	UINT u4_ArbRate; // arbitrary up_sampler rate
}HDRADIO_SYSTEM_INFO_t;
typedef enum _VtsAPlus_RxPath_e
{
	VTSAPLUS_RX_PATH_ASI_SMPTE,
	VTSAPLUS_RX_PATH_RF,
	VTSAPLUS_RX_PATH_MAX
}VtsAPlus_RxPath_t;

typedef enum _VtsAPlus_PortType_e
{
	VTSAPLUS_PORT_TYPE_ASI,
	VTSAPLUS_PORT_TYPE_SMPTE,
	VTSAPLUS_PORT_TYPE_MAX
}VtsAPlus_PortType_t;

typedef enum _VtsAPlus_SMPTE_PLLType_e
{
	VTSAPLUS_SMPTE_PLL_24MHZ,
	VTSAPLUS_SMPTE_PLL_38_P_78531692MHZ,
	VTSAPLUS_SMPTE_PLL_19_P_39265846MHZ,
	VTSAPLUS_SMPTE_PLL_MAX
}VtsAPlus_SMPTE_PLLType_t;
typedef enum _VtsAPlus_RFSignalCondition_e
{
	VTSAPLUS_RFSIGNAL_NO			= 0,
	VTSAPLUS_RFSIGNAL_WEAK		= 1,
	VTSAPLUS_RFSIGNAL_MODERATE	= 2,
	VTSAPLUS_RFSIGNAL_STRONG		= 4,
	VTSAPLUS_RFSIGNAL_VERY_STRONG	= 8
}VtsAPlus_RFSignalCondition_t;

typedef enum _VtsAPlus_RFSignalInvert_e
{
	VTSAPLUS_RFSIGNAL_NOT_INVERTED			= 0,
	VTSAPLUS_RFSIGNAL_INVERTED		= 1,
}VtsAPlus_RFSignalInvert_t;
#ifdef VTS_API_USE_NAMESPACE
}       //end of namespace
#endif

#endif // VENTUS_H
