///////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <dbt.h>
#include <vector>
#include <afxpriv.h>

#include "conio.h"          // kbhit(), etc.
using namespace std;

#include "VentusGUID.h"
#include "Ventus.h"
#include "VtsAPI.h"


///////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CLI_INPUT_STR_LENGTH	70
#define CLI_CMD_STR_LENGTH		20

#define IF_ERROR_PRINT(func) 	if((t_Return = func)!= VTS_SUCCESS)printf("%s:"__FUNCTION__"() %dLine: t_Return = 0x%08X \n",__FILE__,__LINE__,t_Return)
#define IF_ERROR_PRINT_BREAK(func) if((t_Return = func)!= VTS_SUCCESS){printf("%s:"__FUNCTION__"() %dLine: t_Return = 0x%08X \n",__FILE__,__LINE__,t_Return); break;}
#define IF_ERROR_PRINT_RETURN(func) if((t_Return = func)!= VTS_SUCCESS){printf("%s:"__FUNCTION__"() %dLine: t_Return = 0x%08X \n",__FILE__,__LINE__,t_Return); return t_Return;}
#define IF_ERROR_RETURN(func) 	if((t_Return = func)!= VTS_SUCCESS)return t_Return
#define IF_ERROR_BREAK(func) 	if((t_Return = func)!= VTS_SUCCESS)break
#define IF_ERROR_CONTINUE(func) if((t_Return = func)!= VTS_SUCCESS)continue

///////////////////////////////////////////////////////////////////////////////
//CVtsAPI gc_VtsAPI;

using namespace std;

enum enModeType{MODE_COMMAND = 0, MODE_FILE};

unsigned int gu4_VectorIndex = 0;
vector<CString>gvec_Command;
enModeType gen_ModeType;

FILE* g_stream;

CFile gc_File;
CFileStatus gc_FileStatus;
ULONGLONG gu8_file_length, gu8_file_position;
char gs1a_InputStr[CLI_INPUT_STR_LENGTH + 1];
bool gb_Write, gb_Read;
VTS_PumpState_t gt_PumpState;
VTS_PumpMode_t gt_PumpMode;
VTS_BroadcastType_t gt_BcType;

int gs4_IsdbtFrameSize = 0;
int gs4_IsdbtOffSet = 0;

int gs4_CmmbFrameSize = 0;
int gs4_CmmbOffSet = 0;
bool gb_IsMultiCh = true;
int gs4_CmmbSyncError = 0;

int gs4_DTMBOffSet = 0;
int gs4_DTMBFrameSize = 0;


int gs4_ATSCMHFrameSize = 0;

typedef struct _CmmbFile_t 
{
	CFile	c_File;
	int		ms4_Offset;
	int		ms4_FrameSize;
}CmmbFile_t;

void CmmbCheckClch(CmmbClchCheck_t t_ClchCheck);
void CmmbShowConfig(CmmbConfig_t t_Config);



unsigned int gu4_BuffSize, gu4_BuffUsed, gu4_RxRate_bps;

wchar_t RpciClassName[] = _T("Windowless Window");

/////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK
RpciWndProc(
    HWND hWnd, 
    UINT Msg, 
    WPARAM wParam, 
    LPARAM lParam
    )
{
	VTS_Return_t t_Return;

	switch (Msg)
	{
		case WM_DEVICECHANGE:
		{
			// Device arrival/removal
			PDEV_BROADCAST_HDR pdbch = (PDEV_BROADCAST_HDR) lParam;
			
			if (!pdbch)
			{
				// Unidentified device
				break;
			}

			switch(pdbch->dbch_devicetype)
		        {
				case DBT_DEVTYP_DEVICEINTERFACE:
				{
					PDEV_BROADCAST_DEVICEINTERFACE pdbcd = (PDEV_BROADCAST_DEVICEINTERFACE) lParam;
					switch(wParam)
					{   // VENTUS device arrival/removal
						case DBT_DEVICEARRIVAL:
						{
							printf("%s has been arrived!\n", pdbcd->dbcc_name);
							if(CheckDevice())
							{
								printf("To open it, close the open one!\r\n");
							}
							else
							{
								printf("You can open it now!\r\n");
							}
						}
						break;
		           			case DBT_DEVICEREMOVECOMPLETE:
						{
							printf("%s has been removed!\r\n", pdbcd->dbcc_name);
							if(CheckDevice())
							{
								char s1p_DevicePath[VTS_API_DEVICE_PATH_MAX];
								char s1a_Temp[VTS_API_DEVICE_PATH_MAX+1];
								size_t t_Size;

								IF_ERROR_PRINT_BREAK(GetDevicePath(GetDeviceIndex(), s1p_DevicePath));
								wcstombs_s(&t_Size, s1a_Temp, VTS_API_DEVICE_PATH_MAX, pdbcd->dbcc_name, VTS_API_DEVICE_PATH_MAX); 
								if(0 == _strnicmp(s1a_Temp, s1p_DevicePath, sizeof(s1p_DevicePath)))
								{
									IF_ERROR_PRINT(CloseDevice());
									else
										printf("%s has been closed!\r\n", pdbcd->dbcc_name);
								}
							}
		           			}
						break;
		            		}
				}
				break;
			}
		}
		break;
	}
	return DefWindowProc(hWnd, Msg, wParam, lParam);
}

UCHAR gu1a_Buff[1024*1024*8];

void ClearVector(void)
{
	gu4_VectorIndex = 0;
	gvec_Command.clear();
}

void DataProcess(void)
{
	VTS_Return_t t_Return = VTS_SUCCESS;

	ULONG u4_RdWrSize;
	ULONG u4_TransferedBytes;
	UINT u4_FileReadBytes;
	LONG s4_Differ = 0; 

	//Set Size
	switch(gt_BcType)
	{
		case VTS_BC_ISDB_T:
			if(gs4_IsdbtFrameSize == 0) return;
			u4_RdWrSize = gs4_IsdbtFrameSize;
		break;
		case VTS_BC_DTMB:
			if(gs4_DTMBFrameSize == 0) return;
			u4_RdWrSize = gs4_DTMBFrameSize;
		break;
		case VTS_BC_ATSC_MH:
			if(gs4_ATSCMHFrameSize == 0) return;
			u4_RdWrSize = gs4_ATSCMHFrameSize;
		break;
		default:
			if(gt_PumpMode == VTS_PUMP_MODE_ASI_IN)
				u4_RdWrSize = CVtsAPI::READ_SIZE_TS;
			else
				u4_RdWrSize = CVtsAPI::WRITE_SIZE_TS;
		break;
	}

	if((gt_PumpMode == VTS_PUMP_MODE_ASI_OUT 
		|| gt_PumpMode == VTS_PUMP_MODE_RF_OUT 
		|| gt_PumpMode == VTS_PUMP_MODE_RF_OUT_RAW)
		&& gt_PumpState == VTS_PUMP_STATE_RUN)
	{
		switch(gt_BcType)
		{
			case VTS_BC_ATSC_MH:
				//File Open No Check
			break;

			default:
				// File Open Check
				if(!gc_File.GetStatus(gc_FileStatus)) return;
				if(gc_FileStatus.m_atime == NULL) return;
			break;
		}

		// HW Buffer Check
		PumpGetHwBuffUsed(&gu4_BuffUsed, NULL);
		if(gu4_BuffUsed > gu4_BuffSize - u4_RdWrSize)return;

		// Pump
		switch(gt_BcType)
		{
			case VTS_BC_ATSC_MH:
			{
				PumpWrite(0, 0, 0, false);
			}
			break;

			case VTS_BC_CMMB:
			{			
				CmmbConfig_t t_Config;
				CMMB_GetConfig(&t_Config);
	
				int s4_NewFrameSize = 0;
				unsigned char u1_MfId = 2;
				bool b_IsPadding;
				
				if (gb_IsMultiCh == false)				
					b_IsPadding = t_Config.mt_Lch[u1_MfId].mb_IsFramePadding;					
				else				
					b_IsPadding = t_Config.mb_Is0xFFpadding;				
	
				ULONG u4_ReadSize = 0;
				
				if (t_Config.mb_IsTs == true)		/*case that the type of input stream is TS*/
				{								
					unsigned char* u1p_Src = gu1a_Buff; 			
					unsigned int u4_MaxSize = gs4_CmmbFrameSize;
					
					while(1)
					{
						if(gc_File.Read(u1p_Src, 188) != 188)
							break;
						if ((((u1p_Src[1]&0x1f)<<8) + u1p_Src[2]) != 0x1fff)
						{
							u1p_Src += 188;
							u4_ReadSize += 188;
							if(u4_ReadSize == u4_MaxSize)
							{
								CMMB_TransTs2Mfs(gu1a_Buff, u4_MaxSize);
								break;
							}									
						}
					}				
				}
				else		/*case that the type of input stream is MFS*/
					u4_ReadSize = gc_File.Read(gu1a_Buff, gs4_CmmbFrameSize);
				u4_FileReadBytes = u4_ReadSize;
	
				if(b_IsPadding == false)
				{					
					ULONGLONG u8_FilePosition = gc_File.GetPosition();
					ULONGLONG u8_FileLength = gc_File.GetLength();
	
					if (gb_IsMultiCh == false)	/*Single MFS*/
					{
						s4_NewFrameSize = CMMB_CheckMfSize(gb_IsMultiCh, u1_MfId, gu1a_Buff);
						if((u4_ReadSize != s4_NewFrameSize) && (u8_FilePosition != gc_File.GetLength()))
						/*If frame size were different between previous frame and current frame each other, then.. */
						{
							gc_File.Seek(-((int)u4_ReadSize), CFile::current);
							gs4_CmmbFrameSize = s4_NewFrameSize;
							u4_ReadSize = gc_File.Read(gu1a_Buff, gs4_CmmbFrameSize);
						}
					} 
					else		/*Multi MFS*/
					{					
						if (u8_FilePosition != u8_FileLength)		/*Check whether stream reach end of file.*/
						{		
							bool b_End = false;
							gc_File.Seek(-((int)u4_ReadSize), CFile::current);
							u4_FileReadBytes = 0;
							for(int i=0; i<t_Config.ms4_FrameN; i++)
							{
								gc_File.Read(gu1a_Buff + u4_FileReadBytes, 5);		//Get Header Length
								if(gc_File.GetPosition() == u8_FileLength)		//Check the end of the file
								{										
									b_End = true;
									break;
								}
								gc_File.Seek(-5, CFile::current);
								u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, gu1a_Buff[u4_FileReadBytes + 4] + 4);
								if(gc_File.GetPosition() == u8_FileLength)		//Check the end of the file
								{										
									b_End = true;
									break;
								}											
								s4_NewFrameSize = CMMB_CheckMfSize(gb_IsMultiCh, i, gu1a_Buff + u4_FileReadBytes);
								gc_File.Seek(-((int)u4_ReadSize), CFile::current);
								u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, s4_NewFrameSize);
								if(gc_File.GetPosition() == u8_FileLength)		//Check the end of the file
								{										
									b_End = true;
									break;
								}											
								u4_FileReadBytes += u4_ReadSize;
							}
							if (b_End == false)
							{
								u4_ReadSize = u4_FileReadBytes;
								gs4_CmmbFrameSize = u4_ReadSize;											
							} 
							else
								u4_ReadSize = 0;												
						}	/*End of checking whether stream reach the end of file*/
					}		/*End	of checking whether stream is S-MFS, or not*/
				}			/*End	of checking whether stream include stuffing data.*/
	
				/*Reading process from stream is completed*/			
				/*Check whether the stream reached end of the file*/
				/*If the stream is at the end of file, then move the file pointer at the beginning of file and try to read again*/
				if(u4_ReadSize != gs4_CmmbFrameSize)		/*If stream is in end of file*/
				{
					printf("End of File!\r\n");
					gc_File.Seek(gs4_CmmbOffSet, CFile::begin); 	
					if (t_Config.mb_IsTs == true)		/*case that the type of input stream is TS*/
					{
						u4_ReadSize = 0;
						unsigned char* u1p_Src = gu1a_Buff; 				
						while(1)
						{
							if(gc_File.Read(u1p_Src, 188) != 188)
								break;
							if ((((u1p_Src[1]&0x1f)<<8) + u1p_Src[2]) != 0x1fff)
							{
								u1p_Src += 188;
								u4_ReadSize += 188;
								if(u4_ReadSize == gs4_CmmbFrameSize)
								{
									CMMB_TransTs2Mfs(gu1a_Buff, gs4_CmmbFrameSize);
									break;
								}									
							}
						}				
					}
					else		/*case that the type of input stream is MFS*/
						u4_ReadSize = gc_File.Read(gu1a_Buff, gs4_CmmbFrameSize);
	
					if(b_IsPadding == false)
					{								
						if (gb_IsMultiCh == false)
						{
							s4_NewFrameSize = CMMB_CheckMfSize(gb_IsMultiCh, u1_MfId, gu1a_Buff);
							if(u4_ReadSize != s4_NewFrameSize)
							{
								gc_File.Seek(-((int)u4_ReadSize), CFile::current);
								gs4_CmmbFrameSize = s4_NewFrameSize;
								u4_ReadSize = gc_File.Read(gu1a_Buff, gs4_CmmbFrameSize);
							}
						}
						else
						{
							gc_File.Seek(-((int)u4_ReadSize), CFile::current);
							ULONG u4_FileReadBytes = 0;
							for(int i=0; i<t_Config.ms4_FrameN; i++)
							{
								gc_File.Read(gu1a_Buff + u4_FileReadBytes, 5);		//Get Header Length 									
								gc_File.Seek(-5, CFile::current);
								u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, gu1a_Buff[ u4_FileReadBytes + 4] + 4); 										
								s4_NewFrameSize = CMMB_CheckMfSize(gb_IsMultiCh, i, gu1a_Buff + u4_FileReadBytes);
								gc_File.Seek(-((int)u4_ReadSize), CFile::current);
								u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, s4_NewFrameSize);
								u4_FileReadBytes += u4_ReadSize;
							}										
							u4_ReadSize = u4_FileReadBytes;
							gs4_CmmbFrameSize = u4_ReadSize;
						}
					}
				}	
				
				/*Check the sync of MFS*/
				int s4_CmmbOffset = 0;			
				if(CMMB_CHECK_SYNC_W(gc_File.GetFilePath().GetBuffer(), gc_File.GetPosition(), &s4_CmmbOffset, &gs4_CmmbFrameSize, gb_IsMultiCh,
							t_Config, gu1a_Buff) != VTS_SUCCESS )
				{
					gc_File.Seek(s4_CmmbOffset, CFile::begin);
					if(b_IsPadding == false)
					{
						u4_FileReadBytes = 0;
						for(int i=0; i<t_Config.ms4_FrameN; i++)
						{
							gc_File.Read(gu1a_Buff + u4_FileReadBytes, 5);		//Get Header Length 										
							gc_File.Seek(-5, CFile::current);
							u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, gu1a_Buff[ u4_FileReadBytes + 4] + 4); 										
							s4_NewFrameSize = CMMB_CheckMfSize(gb_IsMultiCh, i, gu1a_Buff + u4_FileReadBytes);
							gc_File.Seek(-((int)u4_ReadSize), CFile::current);
							u4_ReadSize = gc_File.Read(gu1a_Buff + u4_FileReadBytes, s4_NewFrameSize);							
							u4_FileReadBytes += u4_ReadSize;
						}
					}
					else 
						u4_ReadSize = gc_File.Read(gu1a_Buff, gs4_CmmbFrameSize);
				}

				
				IF_ERROR_PRINT(PumpWrite(gu1a_Buff, u4_FileReadBytes, &u4_TransferedBytes, false));
				
				// File Point Check
				s4_Differ = (LONG)(u4_TransferedBytes - u4_FileReadBytes);
				gc_File.Seek(s4_Differ, CFile::current);
				
				// File End Check
				gu8_file_position = gc_File.GetPosition();
				if(gu8_file_position >= gu8_file_length) 
				{
					printf("End of File!\r\n");
				
					if(gt_BcType == VTS_BC_ISDB_T)
						gc_File.Seek(gs4_IsdbtOffSet, CFile::begin);
					else if(gt_BcType == VTS_BC_DTMB)
						gc_File.Seek(gs4_DTMBOffSet, CFile::begin);
					else
						gc_File.SeekToBegin();
				}
			}
			break;

			default:
				
				u4_FileReadBytes = gc_File.Read(gu1a_Buff, u4_RdWrSize);
				IF_ERROR_PRINT(PumpWrite(gu1a_Buff, u4_FileReadBytes, &u4_TransferedBytes, false));

				// File Point Check
				s4_Differ = (LONG)(u4_TransferedBytes - u4_FileReadBytes);
				gc_File.Seek(s4_Differ, CFile::current);
				
				// File End Check
				gu8_file_position = gc_File.GetPosition();
				if(gu8_file_position >= gu8_file_length) 
				{
					printf("End of File!\r\n");
				
					if(gt_BcType == VTS_BC_ISDB_T)
						gc_File.Seek(gs4_IsdbtOffSet, CFile::begin);
					else if(gt_BcType == VTS_BC_DTMB)
						gc_File.Seek(gs4_DTMBOffSet, CFile::begin);
					else
						gc_File.SeekToBegin();
				}

			break;
		}
	}
	// ASI-IN
	else if((gt_PumpMode == VTS_PUMP_MODE_ASI_IN)
		&& gt_PumpState == VTS_PUMP_STATE_RUN)
	{
		// HW Buffer Check
		PumpGetHwBuffUsed(&gu4_BuffUsed, NULL);
		if(gu4_BuffUsed < u4_RdWrSize) return;

		IF_ERROR_PRINT(PumpRead(gu1a_Buff, u4_RdWrSize, &u4_TransferedBytes));
		gc_File.Write(gu1a_Buff, u4_TransferedBytes);
	}
	else
	{
		Sleep(0);
	}
}

void PrintCommandLine(void)
{
	bool b_RemuxOnOff;
	VTS_TS_Format_t t_OutTsFormat, t_SrcTsFormat;

	if(!CheckDevice())
	{
		printf("%d Device Available>%s\r", CountDevice(), gs1a_InputStr);
		return;
	}

	static unsigned long u4_UpdateInterleave = 0;

	if(u4_UpdateInterleave > 10)
	{
		PumpGetState(&gt_PumpState);
		PumpGetMode(&gt_PumpMode, &b_RemuxOnOff, &t_OutTsFormat, &t_SrcTsFormat);
		ModulatorGetBcType(&gt_BcType);
		PumpGetRxRate(&gu4_RxRate_bps);
		u4_UpdateInterleave = 0;
	}
	else
		u4_UpdateInterleave++;

	switch(gt_PumpMode)
	{
	case VTS_PUMP_MODE_ASI_IN:
		printf("%d_%8d>%s\r", gt_PumpState, gu4_RxRate_bps, gs1a_InputStr);
		break;
	case VTS_PUMP_MODE_ASI_RF:
		printf("%d_%8d>%s\r", gt_PumpState, gu4_RxRate_bps, gs1a_InputStr);
		break;
	case VTS_PUMP_MODE_ASI_OUT:
		printf("%d_%8d>%s\r", gt_PumpState, gu4_BuffUsed, gs1a_InputStr);
		break;
	case VTS_PUMP_MODE_RF_OUT:
		printf("%d_%8d>%s\r", gt_PumpState, gu4_BuffUsed, gs1a_InputStr);
		break;
	case VTS_PUMP_MODE_RF_OUT_RAW:
		printf("%d_%8d>%s\r", gt_PumpState, gu4_BuffUsed, gs1a_InputStr);
		break;
	default:
		printf("BadPumpMode>%s\r", gs1a_InputStr);
		break;
	}
}

const char* GetBcTypeString(VTS_BroadcastType_t t_BcType)
{
	const char* s1a_BcType[] = {
		"NULL",
		"CW",
		"DVB-S",
		"DVB-S2",
		"DVB-T/H(2k/8k)",
		"DVB-T/H(4k)",
		"DVB-C",
		"ATSC",
		"QAM-B",
		"QAM-C",
		"ISDB-T",
		"T-DMB",
		"DTMB",
		"CMMB Mux",
		"ATSC-MH Non Mux",
		"CMMB Non Mux"
	};

	return s1a_BcType[t_BcType];
}

void PrintBcTypes(void)
{
	printf("%3d = CW \r\n", VTS_BC_CW);
	printf("%3d = DVB-S \r\n", VTS_BC_DVB_S);
	printf("%3d = DVB-S2  \r\n", VTS_BC_DVB_S2);
	printf("%3d = DVB-T/H(2k/8k)  \r\n", VTS_BC_DVB_T);
	printf("%3d = DVB-T/H(4k)  \r\n", VTS_BC_DVB_H);
	printf("%3d = DVB-C  \r\n", VTS_BC_DVB_C);
	printf("%3d = ATSC  \r\n", VTS_BC_ATSC);
	printf("%3d = QAM-B  \r\n", VTS_BC_QAM_B);
	printf("%3d = QAM-C  \r\n", VTS_BC_QAM_C);
	printf("%3d = ISDB-T  \r\n", VTS_BC_ISDB_T);
	printf("%3d = T-DMB  \r\n", VTS_BC_T_DMB);
	printf("%3d = DTMB  \r\n", VTS_BC_DTMB);
	printf("%3d = CMMB MUX \r\n", VTS_BC_CMMB);
	printf("%3d = ATSC-MH Non MUX  \r\n", VTS_BC_ATSC_MH);
	printf("%3d = CMMB Non MUX \r\n", VTS_BC_CMMB_NON_MULTIPLEX);
}

void CLI_Process(void)
{
	VTS_Return_t t_Return = VTS_SUCCESS;

	static time_t t_TimerStart; //  
	static time_t t_TimeToWait; //  
	time_t t_TimeNow;

	if(t_TimerStart + t_TimeToWait > time(&t_TimeNow))
	{
		printf("Timer run  : %d> ", t_TimeNow);
		return;
	}

	if(gen_ModeType == MODE_FILE)
	{
		do 
		{
			char u1_Command[64];
			memset(u1_Command, 0, 64);

			if(fgets(u1_Command, 64, g_stream) == NULL)
			{
				gen_ModeType = MODE_COMMAND;
				printf("\r\n*** End of Script ***\r\n");
				break;
			}
			else
			{
				if(u1_Command[0] == '#' || u1_Command[0] == 0x0a)
					continue;

				strcpy_s(gs1a_InputStr, sizeof(u1_Command), u1_Command);
				break;
			}

		} while (TRUE);
	}
	static unsigned short u2_KeyCount = 0;

	if(gen_ModeType == MODE_FILE || _kbhit()) 
	{
		char s1a_CmdStr[CLI_CMD_STR_LENGTH + 1];
		char* s1p_ParamStr;
		short s2_ParamRead;
		unsigned int u4_Temp1, u4_Temp2, u4_Temp3, u4_Temp4, u4_Temp5,
			u4_Temp6, u4_Temp7, u4_Temp8, u4_Temp9;		

		char s1_CharIn;

		if(gen_ModeType == MODE_COMMAND)
			s1_CharIn = _getch();
		else
		{
			s1_CharIn = '\r';
			printf("%d Device Available>%s\r", CountDevice(), gs1a_InputStr);
		}

		if(s1_CharIn == '\n' || s1_CharIn == '\r')
		{
			printf("\r\n");

			s2_ParamRead = sscanf_s(gs1a_InputStr, "%s", s1a_CmdStr, CLI_CMD_STR_LENGTH);

			s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);

			if(strcmp(s1a_CmdStr, "help") == 0)
			{
				printf("ver         : Get API Version Information\r\n");
				printf("wait        : Wait 100msec or defined msec\r\n");
				printf("timer       : Delay command execution 1sec or defined sec\r\n");
				printf("d-open      : Device Open\r\n");
				printf("d-close     : Device Close\r\n");
				printf("d-sn        : Get Device Serial Number\r\n");
				printf("p-mode      : Set/Get Pump Mode\r\n");
				printf("p-ctrl      : Set/Get Pump Control\r\n");
				printf("p-state     : Set/Get Pump State(Run/Stop/Pause)\r\n");
				printf("p-raw-rate  : Set/Get Pump Raw(input) rate\r\n");
				printf("p-conv-rate : Set/Get Pump Conversion Rate\r\n");
				printf("p-used-word : Get Pump Hardware Buffer used in bytes\r\n");
				printf("p-bctype    : Get Broadcast(Modulation) Type Capability\r\n");
				printf("m-init      : Set Broadcast(Modulation) Type and Initialize\r\n");
				printf("m-rf        : Set/Get Modulation Radio Frequency\r\n");
				printf("m-if        : Set/Get Intermediate Frequency\r\n");
				printf("m-sps       : Set/Get Modulation Symbol rate\r\n");
				printf("th-mode     : Set/Get DVB-TH Mode\r\n");
				printf("th-cell     : Set/Get DVB-H Cell ID\r\n");
				printf("th-bw       : Set/Get DVB-TH Bandwidth\r\n");
				printf("th-bps      : Get DVB-TH Bit Rate\r\n");
				printf("eti         : Get ETI file information opened\r\n");
				printf("isdbt       : Get information about script of ISDB-T mode\r\n");
				printf("c-mode      : Set/Get DVB-C mode\r\n");
				printf("c-bps       : Set/Get DVB-C Bit Rate\r\n");
				printf("cw-level    : Set/Get CW Level Control Value\r\n");
				printf("cw-20dbm    : Set CW Level to -20dBm\r\n");
				printf("f-close     : Close File\r\n");
				printf("f-open      : Open File\r\n");
				printf("f-create    : Create File\r\n");
				printf("ao          : Set/Get Atten+ Output Level\r\n");
				printf("af          : Set/Get Atten+ Frequency\r\n");
				printf("as          : Set/Get Atten+ Output Switch state(On/Off)\r\n");
				printf("at          : Get Atten+ Temperature\r\n");
				printf("eep1		: Read/Write unsigned 1 byte integer from/to EEPROM \r\n");
				printf("eep4		: Read/Write signed 4 byte integer from/to EEPROM \r\n");
				printf("eep-dump	: Dump EEPROM data \r\n");
				printf("Command without parameter, shows usage!\r\n");
			}

			else if(strcmp(s1a_CmdStr, "ver") == 0)
			{
				printf("%s \r\n", GetApiVersionString());
			}

			else if(strcmp(s1a_CmdStr, "wait") == 0)
			{
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					Sleep(u4_Temp1);
					break;
				default:
					Sleep(100);
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "timer") == 0)
			{
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_TimeToWait = u4_Temp1;
					break;
				default:
					t_TimeToWait = 1;
					break;
				}
				t_TimerStart = time(NULL);
				printf("Timer Start: %d\r\n", t_TimerStart);
			}

			else if(strcmp(s1a_CmdStr, "d-open") == 0)
			{
				if(CheckDevice())
				{
					printf("Device already open!\r\n");
				}
				else
				{
					unsigned long u4_DeviceIndex = 0;
					unsigned long u4_DeviceCount = CountDevice();
					if(u4_DeviceCount == 0)
						printf("Device not found!\r\n");
					else
					{						
						s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
						s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

						switch(s2_ParamRead)
						{
							case 1:
								{
									u4_DeviceIndex = u4_Temp1;
									printf("Selected device : %d!\r\n", u4_DeviceIndex);
								}
						

								IF_ERROR_PRINT(OpenDevice(u4_DeviceIndex));
								if(t_Return != VTS_SUCCESS)
									printf("Device open fail!\r\n");
								else
								{
									VTS_PumpID_t t_PumpID;
									IF_ERROR_PRINT(PumpGetID(u4_DeviceIndex, &t_PumpID));
									else printf("Pump ID     = %04d.%02d.%02d\r\n",
										t_PumpID.bf16_ID, 
										t_PumpID.bf8_VersionMajor,
										t_PumpID.bf8_VersionMinor);

									VTS_AttenuatorID_t t_AttenuatorID;
									if(AttenGetID(&t_AttenuatorID) != VTS_SUCCESS)
										printf("Attenuator not found!\r\n");
									else
									{
										printf("Attenuator ID = %02d.%02d.%02d.%02d\r\n",
										t_AttenuatorID.bf8_ID,
										t_AttenuatorID.bf8_VersionHw,
										t_AttenuatorID.bf8_VersionMajor,
										t_AttenuatorID.bf8_VersionMinor);

										SkyBandGetExistence();
									}

									IF_ERROR_PRINT(PumpGetHwBuffSize(&gu4_BuffSize));
									else printf("Hardware Buffer Size = %d(0x%X)\r\n", gu4_BuffSize, gu4_BuffSize);
								}
							break;
							default:
							{
								printf("Select device : 0~%d!\r\n", u4_DeviceCount-1);								
								//scanf("%d", &u4_Temp1);
								//u4_DeviceIndex = u4_Temp1;
							}
							break;
						}		
					}
				}
			}

			else if(strcmp(s1a_CmdStr, "d-close") == 0)
			{
				if(!CheckDevice())
				{
					printf("Device not open!\r\n");
				}
				else
				{
					IF_ERROR_PRINT(CloseDevice());
					else
					{
						char s1p_DevicePath[VTS_API_DEVICE_PATH_MAX];
						IF_ERROR_PRINT(GetDevicePath(0, s1p_DevicePath));
						else printf("%s has been closed!\r\n", s1p_DevicePath);
					}
				}
			}

			else if(strcmp(s1a_CmdStr, "d-sn") == 0)
			{
				char s1a_SerialNum[20];
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);
				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT(GetSerialNum(u4_Temp1, s1a_SerialNum));
					printf("%s = Serial Number of device %d\r\n", s1a_SerialNum, u4_Temp1);
					break;
				default:
					IF_ERROR_PRINT(GetSerialNum(u4_Temp1, s1a_SerialNum));
					printf("%s = Serial Number \r\n", s1a_SerialNum, u4_Temp1);
					printf("Usage: d-sn [Device Index]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-mode") == 0)
			{
				VTS_PumpMode_t gt_PumpMode;
				VTS_TS_Format_t t_OutTsFormat, t_SrcTsFormat;
				bool b_RemuxOnOff;

				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d %d %d",
					&u4_Temp1, &u4_Temp2, &u4_Temp3, &u4_Temp4);
				switch(s2_ParamRead)
				{
				case 4:
					gt_PumpMode = (VTS_PumpMode_t)u4_Temp1;
					b_RemuxOnOff = (u4_Temp2 != 0);
					t_OutTsFormat = (VTS_TS_Format_t)u4_Temp3;
					t_SrcTsFormat = (VTS_TS_Format_t)u4_Temp4;
					
					IF_ERROR_PRINT(PumpSetMode(gt_PumpMode, b_RemuxOnOff,
						t_OutTsFormat, t_SrcTsFormat));

					break;
				default:
					PumpGetMode(&gt_PumpMode, &b_RemuxOnOff, &t_OutTsFormat, &t_SrcTsFormat);
					printf("%2d = Pump Mode(0,1,2,3,6 = ASI-OUT,RF-OUT,ASI-IN,ASI-RF,RF-OUT-RAW) \r\n", gt_PumpMode);
					printf("%2d = Remux (0,1 = Off, On) \r\n", b_RemuxOnOff);
					printf("%2d = Out TS Format(0,1 = 188/204) \r\n", t_OutTsFormat);
					printf("%2d = Source TS Format(0,1 = 188/204) \r\n", t_SrcTsFormat);
					printf("Usage: p-mode [<Pump Mode> <Remux On/Off> <Out TS Format> <Source TS Format>]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-ctrl") == 0)
			{
				bool b_ModResetN, b_AttResetN, b_AsiEqBypass, b_AsiLoopbackEnable, b_AsiEqCarrierDetectN, b_AsiRx188_204;

				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d %d %d",
					&u4_Temp1, &u4_Temp2, &u4_Temp3, &u4_Temp4);
				switch(s2_ParamRead)
				{
				case 4:
					b_ModResetN = (u4_Temp1 != 0);
					b_AttResetN = (u4_Temp2 != 0);
					b_AsiEqBypass = (u4_Temp3 != 0);
					b_AsiLoopbackEnable = (u4_Temp4 != 0);
					
					IF_ERROR_PRINT(PumpSetControl(b_ModResetN, b_AttResetN,
						b_AsiEqBypass, b_AsiLoopbackEnable));

					break;
				default:
					IF_ERROR_PRINT(PumpGetControl(&b_ModResetN, &b_AttResetN, &b_AsiEqBypass,
						&b_AsiLoopbackEnable, &b_AsiEqCarrierDetectN, &b_AsiRx188_204));
					printf("%2d = Modulator Reset# \r\n", b_ModResetN);
					printf("%2d = Attenuator Reset# \r\n", b_AttResetN);
					printf("%2d = ASI-IN Equalizer Bypass \r\n", b_AsiEqBypass);
					printf("%2d = ASI-IN to OUT Loopback Enable \r\n", b_AsiLoopbackEnable);
					printf("%2d = ASI-IN Equalizer Carrier Detect# \r\n", b_AsiEqCarrierDetectN);
					printf("Usage: p-ctrl [<Mod Reset#> <Atten Reset#> <ASI Eq. Bypass> <ASI Loopback>]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-state") == 0)
			{
				VTS_PumpState_t gt_PumpState;

				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);
				switch(s2_ParamRead)
				{
				case 1:
					gt_PumpState = (VTS_PumpState_t)u4_Temp1;
					
					IF_ERROR_PRINT(PumpSetState(gt_PumpState));

					break;
				default:
					IF_ERROR_PRINT(PumpGetState(&gt_PumpState));
					printf("%d = Pump State(0,1,2 = Stop, Stop&Clear Buffer, Run) \r\n", gt_PumpState);
					printf("Usage: p-state [Pump State]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-raw-rate") == 0)
			{
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);
				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT(PumpSetRawRate(u4_Temp1));
					break;
				default:
					IF_ERROR_PRINT(PumpGetRawRate(&u4_Temp1));
					printf("%d = Pump raw rate in bps \r\n", u4_Temp1);
					printf("Usage: p-raw-rate [rate in bps]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-conv-rate") == 0)
			{
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);
				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT(PumpSetConvRate(u4_Temp1));
					break;
				default:
					IF_ERROR_PRINT(PumpGetConvRate(&u4_Temp1));
					printf("%d = Pump conversion rate in bps \r\n", u4_Temp1);
					printf("Usage: p-conv-rate [rate in bps]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "p-used-word") == 0)
			{
				unsigned int u4_BuffUsed;
				IF_ERROR_PRINT(PumpGetHwBuffUsed(&u4_BuffUsed, NULL));
				printf("Buffer Used = %08X(%d) bytes\r\n", u4_BuffUsed, u4_BuffUsed);
			}

			else if(strcmp(s1a_CmdStr, "p-bctype") == 0)
			{
				for(int i=VTS_BC_CW; i<VTS_BC_MAX; i++)
				{
					if(VTS_SUCCESS != PumpGetBcTypeSupport((VTS_BroadcastType_t)i))
						printf("Broadcast Type %7s: Not Support!\r\n", GetBcTypeString((VTS_BroadcastType_t)i));
					else
						printf("Broadcast Type %7s: Support!\r\n", GetBcTypeString((VTS_BroadcastType_t)i));
				}
			}

			else if(strcmp(s1a_CmdStr, "m-init") == 0)
			{
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %x", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT_BREAK(ModulatorInit((VTS_BroadcastType_t)u4_Temp1));
					break;
				default:
					printf("\r\nUsage: m-init <Broadcast Type 0~%d>\r\n", VTS_BC_MAX-1);
					PrintBcTypes();
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "m-rf") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %u", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_Return = ModulatorSetRF(u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				default:
					t_Return = ModulatorGetRF(&u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\nRadio Frequency = %u Hz\r\n", u4_Temp1);
						printf("\r\nUsage: m-rf [Frequency in Hz]\r\n");
					}
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "m-if") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %u", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_Return = ModulatorSetIF(u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				default:
					t_Return = ModulatorGetIF(&u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\nIntermediate Frequency = %u Hz\r\n", u4_Temp1);
						printf("\r\nUsage: m-if [Frequency in Hz]\r\n");
					}
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "m-sps") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_Return = DVB_C_SetSymRate(u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				default:
					t_Return = DVB_C_GetSymRate(&u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n Symbol Rate = %d bd\r\n", u4_Temp1);
						printf("\r\n Usage: m-sps [<baud rate in bd>]\r\n");
					}
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "th-mode") == 0)
			{
				bool b_CellIDEn;
				VTS_DVB_TH_Interleaver_t t_Interleaver;
				bool b_UseMPE_FEC;
				bool b_UseTimeSlicing;
				bool b_DVBHEnable;
				VTS_DVB_TH_GuardInt_t t_GuardInt;
				VTS_DVB_TH_TxMode_t t_TxMode;
				VTS_DVB_TH_Constel_t t_Constel;
				VTS_DVB_TH_CodeRate_t t_CodeRate;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d %d %d %d %d %d %d %d",
					&u4_Temp1, &u4_Temp2, &u4_Temp3, &u4_Temp4, &u4_Temp5, &u4_Temp6,
					&u4_Temp7, &u4_Temp8, &u4_Temp9);

				switch(s2_ParamRead)
				{
				case 9:
					b_CellIDEn			= (u4_Temp1 != 0);
					t_Interleaver		= (VTS_DVB_TH_Interleaver_t)u4_Temp2;
					b_UseMPE_FEC		= (u4_Temp3 != 0);
					b_UseTimeSlicing	= (u4_Temp4 != 0);
					b_DVBHEnable		= (u4_Temp5 != 0);
					t_GuardInt			= (VTS_DVB_TH_GuardInt_t)u4_Temp6;
					t_TxMode			= (VTS_DVB_TH_TxMode_t)u4_Temp7;
					t_Constel			= (VTS_DVB_TH_Constel_t)u4_Temp8;
					t_CodeRate			= (VTS_DVB_TH_CodeRate_t)u4_Temp9;

					IF_ERROR_PRINT(DVB_TH_SetMode(
						b_CellIDEn,
						t_Interleaver,
						b_UseMPE_FEC,
						b_UseTimeSlicing,
						b_DVBHEnable,
						t_GuardInt,
						t_TxMode,
						t_Constel,
						t_CodeRate));
					break;
				default:
					IF_ERROR_PRINT_BREAK(DVB_TH_GetMode(
						&b_CellIDEn,
						&t_Interleaver,
						&b_UseMPE_FEC,
						&b_UseTimeSlicing,
						&b_DVBHEnable,
						&t_GuardInt,
						&t_TxMode,
						&t_Constel,
						&t_CodeRate));

					printf(" %2d = Cell ID Enable(0/1 = Disable/Enable)\r\n", 
						b_CellIDEn);
					printf(" %2d = Interleaver(0/1 = Native/In-depth)\r\n",
						t_Interleaver);
					printf(" %2d = Use MPE FEC(0/1 = No/Yes)\r\n",
						b_UseMPE_FEC);
					printf(" %2d = Use Time-Slicing(0/1 = No/Yes)\r\n",
						b_UseTimeSlicing);
					printf(" %2d = DVB-H Enable(0/1 = Disable/Enable) \r\n",
						b_DVBHEnable);
					printf(" %2d = Guard Interval(0,1,2,3 = 1/32,1/16,1/8,1/4)\r\n",
						t_GuardInt);
					printf(" %2d = Tx. Mode(0/1/2 = 2K/8K/4K)\r\n",
						t_TxMode);
					printf(" %2d = Constellation(0/1/2 = QPSK/16-QAM/64-QAM)\r\n",
						t_Constel);
					printf(" %2d = Code Rate(0,1,2,3,4 = 1/2,2/3,3/4,5/6,7/8)\r\n",
						t_CodeRate);
					printf("\r\nUsage: th-mode [<CellIDEn> <Interleaver> <MPE-FEC> <TimeSlicing> <DVBHEnable> <GuardInt> <TxMode> <Constellation> <CodeRate>]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "th-cell") == 0)
			{
				unsigned short u2_CellID;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT(t_Return = DVB_TH_SetCellID((unsigned short)u4_Temp1));
					break;
				default:
					IF_ERROR_PRINT(t_Return = DVB_TH_GetCellID(&u2_CellID));
					printf("\r\n %d = Cell ID\r\n", u2_CellID);
					printf("\r\nUsage: th-cell [Cell ID in Decimal]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "th-bw") == 0)
			{
				unsigned char u1_BandWidth;
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %u", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					u1_BandWidth = (unsigned char)u4_Temp1;
					t_Return = DVB_TH_SetBandWidth(u1_BandWidth);
					if(t_Return != VTS_SUCCESS)
					{
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
						break;
					}
					printf("OK!\r\n");
					break;
				default:
					t_Return = DVB_TH_GetBandWidth(&u1_BandWidth);
					if(t_Return != VTS_SUCCESS)
					{
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
						break;
					}
					printf("\r\nBandwidth = %d MHz\r\n", u1_BandWidth);
					printf("\r\nUsage: th-bw [Frequency in MHz]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "th-bps") == 0)
			{
				t_Return = DVB_TH_GetBitRate(&u4_Temp1);
				if(t_Return != VTS_SUCCESS)
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
				{
					printf("\r\n Data Rate = %d bps\r\n", u4_Temp1);
					printf("\r\n Usage: th-bps\r\n");
				}
			}

			else if(strcmp(s1a_CmdStr, "eti") == 0)
			{
				int s4_BufferOffset, s4_FramePhase, s4_Mode;
				unsigned long u4_RdWrSize = CVtsAPI::WRITE_SIZE_ETI*4;
				unsigned long u4_FileReadBytes;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);
				switch(s2_ParamRead)
				{
				case 1:
					break;
				default:
					u4_Temp1 = 0;
					break;
				}

				gc_File.Seek(u4_Temp1, CFile::begin);
				u4_FileReadBytes = gc_File.Read(gu1a_Buff, u4_RdWrSize);
				IF_ERROR_PRINT(T_DMB_Parse(gu1a_Buff, u4_FileReadBytes, false));

				IF_ERROR_PRINT(T_DMB_GetMode(&s4_Mode));
				IF_ERROR_PRINT(T_DMB_GetBufferOffset(&s4_BufferOffset));
				IF_ERROR_PRINT(T_DMB_GetFramePhase(&s4_FramePhase));
				printf("Mode: %d\r\n",s4_Mode);
				printf("Offset: %d\r\n", s4_BufferOffset);
				printf("Frame Phase: %d\r\n", s4_FramePhase);

				gc_File.Seek(s4_BufferOffset, CFile::begin);
				gu8_file_position = gc_File.GetPosition();
			}
			else if(strcmp(s1a_CmdStr, "dtmb-parse") == 0)
			{
				bool b_IsISDB = false;
				CString csFilePath = gc_File.GetFilePath();
				TCHAR* tchFilePath;
				tchFilePath = csFilePath.GetBuffer(csFilePath.GetLength());

				/*Check whether CFile is valid or not*/
				if (_tcslen(tchFilePath) == 0)				
					_tprintf(_T("No file is opened\r\n"));					
				else
				{
					DTMB_Initial();
					
					unsigned int u4_DTMB_OffSet;
					unsigned int u4_DTMB_FrameSize;
					unsigned int u4_DTMB_SymRate_bd;
					
					VTS_DTMB_CONFIG_t t_Config;
					
					int s4_DTMB_OutBitRate_bps;
					int s4_RawRate_bps;
					
					/*Check whether the stream is for dtmb or not*/
					//DTMB_IsDTMBTS :OK -> Auto SetMode.
					if(DTMB_IsDTMBTS_W(tchFilePath, &u4_DTMB_OffSet, &u4_DTMB_FrameSize) != VTS_SUCCESS)
					{
						_tprintf(_T("%s is not DTMB stream.\r\n"), tchFilePath);
						gc_File.Close();	
					}
					else
					{
						DTMB_GetSymRate(&u4_DTMB_SymRate_bd);	
						DTMB_GetOutBitRate(&s4_DTMB_OutBitRate_bps);
						DTMB_GetSrcBitRate(&s4_RawRate_bps);	
						DTMB_GetMode(&t_Config);

						_tprintf(_T("  Stream : %s\r\n"), tchFilePath);
						_tprintf(_T("  File Offset: %d\r\n"), u4_DTMB_OffSet);
						_tprintf(_T("  Frame Size: %d\r\n"), u4_DTMB_FrameSize);
						_tprintf(_T("  Frame Symbol Rate: %d\r\n"), u4_DTMB_SymRate_bd);
						_tprintf(_T("  Out Bit Rate: %d\r\n"), s4_DTMB_OutBitRate_bps);
						_tprintf(_T("  Stream Bit Rate : %d\r\n"), s4_RawRate_bps);

						gs4_DTMBFrameSize = u4_DTMB_FrameSize;
						gs4_DTMBOffSet = u4_DTMB_OffSet;
						gc_File.Seek(gs4_DTMBOffSet, CFile::begin);
					}
				}
			}
			else if(strcmp(s1a_CmdStr, "atscmh-parse") == 0)
			{
				bool b_IsISDB = false;
				CString csFilePath = gc_File.GetFilePath();
				TCHAR* tchFilePath;
				tchFilePath = csFilePath.GetBuffer(csFilePath.GetLength());
				VTS_Return_t t_TsType = VTS_SUCCESS;

				gc_File.Close();

				/*Check whether CFile is valid or not*/
				if (_tcslen(tchFilePath) == 0)				
					_tprintf(_T("No file is opened\r\n"));					
				else
				{
					unsigned int u4_ATSC_MH_LegacyBitRate;
					unsigned int u4_ATSC_MH_FrameSize;
					
					/*Check whether the stream is for atsc-mh or not*/
					t_TsType = ATSC_MH_SetMainTSPath(tchFilePath);
					if(t_TsType == VTS_ATSC_MH_MAIN_TS)
					{
						_tprintf(_T("Legacy TS stream.\r\n"));
					}
					else if(t_TsType == VTS_ATSC_MH_MH_TS)
					{
						_tprintf(_T("ATSC-MH TS stream.\r\n"));

					}
					else if(t_TsType == VTS_ATSC_MH_ERROR_MAIN_TS_BITRATE_OVERFLOW)
					{
						_tprintf(_T("Bit Rate is over than 19.392Mbps.\r\n"));
					}
					else
					{
						_tprintf(_T("No TS stream.\r\n"));
					}
					
					if(t_TsType == VTS_ATSC_MH_MAIN_TS ||t_TsType == VTS_ATSC_MH_MH_TS)
					{
						ATSC_MH_SetUseLegacy(true);
						ATSC_MH_GetLegacyBitRate(&u4_ATSC_MH_LegacyBitRate);
						ATSC_MH_GetFrameSize(&u4_ATSC_MH_FrameSize);
						
						_tprintf(_T("  Stream : %s\r\n"), tchFilePath);
						_tprintf(_T("  Frame Size: %d\r\n"), u4_ATSC_MH_FrameSize);


						gs4_ATSCMHFrameSize = u4_ATSC_MH_FrameSize;
					}
					else
						gs4_ATSCMHFrameSize  = 0;
					
				}
			}
			else if(strcmp(s1a_CmdStr, "isdbt") == 0)
			{				
				_tprintf(_T("isdbt-parse\t: parse the stream\r\n"));
				_tprintf(_T("isdbt-setlayer\t: change layer parameter(code rate, conste., interleaving)\r\n"));
				_tprintf(_T("isdbt-setmode\t: change OFDM configuration(FFT mode, Guardinterval)\r\n"));
				_tprintf(_T("isdbt-getparam\t: show current configuration information\r\n"));
			}
			else if(strcmp(s1a_CmdStr, "isdbt-parse") == 0)
			{
				bool b_IsISDB = false;
				CString csFilePath = gc_File.GetFilePath();
				TCHAR* tchFilePath;
				tchFilePath = csFilePath.GetBuffer(csFilePath.GetLength());

				/*Check whether CFile is valid or not*/
				if (_tcslen(tchFilePath) == 0)				
					_tprintf(_T("No file is opened\r\n"));					
				else
				{
					/*Check whether the stream is for ISDB-T or not*/
					ISDBT_IsISDBT_TS_W(tchFilePath, &b_IsISDB);
					if (!b_IsISDB)
					{
						_tprintf(_T("%s is not ISDB-T stream.\r\n"), tchFilePath);
						gc_File.Close();						
					}
					else
					{
						unsigned long u4_FileReadBytes;
						u4_FileReadBytes = gc_File.Read(gu1a_Buff, 2089164);
						if(ISDBT_ParseFromBuffer(gu1a_Buff, (int)u4_FileReadBytes) != VTS_SUCCESS)
						{
							_tprintf(_T("%s is not supported.\r\n"), tchFilePath);
							gc_File.Close();
						}
						else
						{						
							ISDBT_GetFrameSize(&gs4_IsdbtFrameSize);
							ISDBT_GetBufferOffset(&gs4_IsdbtOffSet);
							gc_File.Seek(gs4_IsdbtOffSet, CFile::begin);							
						}
					}
				}
			}
			else if(strcmp(s1a_CmdStr, "isdbt-setlayer") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d %d %d", &u4_Temp1, &u4_Temp2, &u4_Temp3, &u4_Temp4);
				switch(s2_ParamRead)
				{
				case 4:
					{
						VTS_ISDB_T_Layer_t t_Layer = (VTS_ISDB_T_Layer_t)u4_Temp1;					
						ISDB_Layer_Parameter_t t_Param = ISDBT_GetLayerParameter(t_Layer);
						t_Param.mu1_CodeRate = (unsigned char)u4_Temp2;
						t_Param.mu1_Modulation = (unsigned char)u4_Temp3;
						t_Param.mu1_TimeIntrlLength = (unsigned char)u4_Temp4;

 						if(ISDBT_SetParameter(t_Layer, t_Param) != VTS_SUCCESS)
							_tprintf(_T("Changing parameter is failed..\r\n"));
					}
					break;
				default:
					{					
						ISDB_Layer_Parameter_t ta_Param[3] = {0,};
						ISDB_OfdmConfig_t t_Config;
						TCHAR* tchLayer[3] = {_T("Layer A"), _T("Layer B"), _T("Layer C")};

						ISDBT_GetParameter(&ta_Param[0], &ta_Param[1], &ta_Param[2], &t_Config);		
						_tprintf(_T(" - Current Parameter\r\n"));
						for(int i=0; i<3; i++)
						{
							if(ta_Param[i].mu1_segment != 0)
							{
								_tprintf(_T(" %2d = Layer(0,1,2 = A, B, C)\r\n"), i);
								_tprintf(_T(" %2d = Code rate(0,1,2,3,4 = 1/2, 2/3, 3/4, 5/6, 7/8)\r\n"), ta_Param[i].mu1_CodeRate);
								_tprintf(_T(" %2d = Modulation(1/2/3 = QPSK/16QAM/64QAM)\r\n"), ta_Param[i].mu1_Modulation);
								if(t_Config.mu1_Mode == 3)
									_tprintf(_T(" %2d = Time Interleaving Length (0, 1, 2, 3 = 0, 1, 2, 4, for Mode3)\r\n\r\n"), ta_Param[i].mu1_TimeIntrlLength);
								else if(t_Config.mu1_Mode == 2)
									_tprintf(_T(" %2d = Time Interleaving Length (0, 1, 2, 3 = 0, 2, 4, 8, for Mode2)\r\n\r\n"), ta_Param[i].mu1_TimeIntrlLength);
								else
									_tprintf(_T(" %2d = Time Interleaving Length (0, 1, 2, 3 = 0, 4, 8, 16, for Mode1)\r\n\r\n"),	ta_Param[i].mu1_TimeIntrlLength);								
							}							
						}	
						_tprintf(_T("\r\nUsage: isdbt-setlayer [<Layer> <Code rate> <Modulation> <Interleaving Length>]\r\n"));	
						_tprintf(_T("\nSelect Layer(0,1,2 = A, B, C) : "));
						
						scanf_s("%d",&u4_Temp1,4);fflush(stdin);	
						VTS_ISDB_T_Layer_t t_Layer = (VTS_ISDB_T_Layer_t)u4_Temp1;
						_tprintf(_T("\nSelect Code rate(0,1,2,3,4 = 1/2, 2/3, 3/4, 5/6, 7/8) : "));
						scanf_s("%d",&u4_Temp1,4);fflush(stdin);
						ta_Param[t_Layer].mu1_CodeRate = (unsigned char)u4_Temp1;
						_tprintf(_T("\nSelect Modulation(1/2/3 = QPSK/16QAM/64QAM) : "));
						scanf_s("%d",&u4_Temp1,4);fflush(stdin);
						ta_Param[t_Layer].mu1_Modulation = (unsigned char)u4_Temp1;
						if(t_Config.mu1_Mode == 1)
							_tprintf(_T("\nSelect Time Interleaving Length (0, 1, 2, 3 = 0, 4, 8, 16) : "));
						else if(t_Config.mu1_Mode == 2)
							_tprintf(_T("\nSelect Time Interleaving Length (0, 1, 2, 3 = 0, 2, 4, 8) : "));
						else if(t_Config.mu1_Mode == 3)
							_tprintf(_T("\nSelect Time Interleaving Length (0, 1, 2, 3 = 0, 1, 2, 4) : "));
						scanf_s("%d",&u4_Temp1,4);fflush(stdin);
						ta_Param[t_Layer].mu1_TimeIntrlLength = (unsigned char)u4_Temp1;

						if(ISDBT_SetParameter(t_Layer, ta_Param[t_Layer]) != VTS_SUCCESS)
							_tprintf(_T("Changing parameter is failed..\r\n"));
					}
					break;
				}			
			}
			else if(strcmp(s1a_CmdStr, "isdbt-setmode") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d", &u4_Temp1, &u4_Temp2);
				if(s2_ParamRead == 2)
				{
					ISDB_OfdmConfig_t t_Config;
					t_Config.mu1_Mode = (unsigned char)u4_Temp1;
					t_Config.mu1_GuardInterval = (unsigned char)u4_Temp2;
					if(ISDBT_SetOfdmConfig(t_Config) != VTS_SUCCESS)
						_tprintf(_T("Changing parameter is failed..\r\n"));
				}
				else
				{
					_tprintf(_T(" - Current status\r\n"));
					ISDB_OfdmConfig_t t_Config = ISDBT_GetOfdmConfig();
					_tprintf(_T(" %2d = Mode(1/2/3 = 2K/4K/8K)\r\n"), t_Config.mu1_Mode);
					_tprintf(_T(" %2d = Guard Interval(0,1,2,3 = 1/32, 1/16, 1/8, 1/4)\r\n"), t_Config.mu1_GuardInterval);
					_tprintf(_T("\r\nUsage: isdbt-setmode [<FFT mode> <Guard interval>]\r\n"));	

					_tprintf(_T("Select Mode(1/2/3 = 2K/4K/8K) :"));
					scanf_s("%d",&u4_Temp1,4);fflush(stdin);
					t_Config.mu1_Mode = (unsigned char)u4_Temp1;					
					_tprintf(_T("\nSelect Guard Interval(0,1,2,3 = 1/32, 1/16, 1/8, 1/4) : "));
					scanf_s("%d",&u4_Temp1,4);fflush(stdin);
					t_Config.mu1_GuardInterval = (unsigned char)u4_Temp1;
					if(ISDBT_SetOfdmConfig(t_Config) != VTS_SUCCESS)
						_tprintf(_T("Changing parameter is failed..\r\n"));
				}
			}
			else if(strcmp(s1a_CmdStr, "isdbt-getparam") == 0)
			{	
				ISDB_Layer_Parameter_t ta_Param[3] = {0,};
				ISDB_OfdmConfig_t t_Config;
				TCHAR* tchLayer[3] = {_T("Layer A"), _T("Layer B"), _T("Layer C")};
				TCHAR* tchGuardinterval[4] = {_T("1/32"), _T("1/16"), _T("1/8"), _T("1/4")};
				TCHAR* tchMapping[3] = {_T("QPSK"), _T("16QAM"), _T("64QAM")};
				TCHAR* tchCodeRate[5] = {_T("1/2"), _T("2/3"), _T("3/4"), _T("5/6"), _T("7/8")};
				unsigned char u1a_IntrlBase[4] = {0, 1, 2, 4};
				ISDBT_GetParameter(&ta_Param[VTS_ISDB_T_Layer_A], &ta_Param[VTS_ISDB_T_Layer_B], &ta_Param[VTS_ISDB_T_Layer_C],
																			&t_Config);
				unsigned int u4a_SrcBitRate[3] = {0,};
				unsigned int u4a_OutRate[3] = {0,};
				ISDBT_GetLayerSrcBitRate(&u4a_SrcBitRate[VTS_ISDB_T_Layer_A], VTS_ISDB_T_Layer_A);
				ISDBT_GetLayerSrcBitRate(&u4a_SrcBitRate[VTS_ISDB_T_Layer_B], VTS_ISDB_T_Layer_B);
				ISDBT_GetLayerSrcBitRate(&u4a_SrcBitRate[VTS_ISDB_T_Layer_C], VTS_ISDB_T_Layer_C);

				ISDBT_GetLayerOutBitRate(&u4a_OutRate[VTS_ISDB_T_Layer_A], VTS_ISDB_T_Layer_A);
				ISDBT_GetLayerOutBitRate(&u4a_OutRate[VTS_ISDB_T_Layer_B], VTS_ISDB_T_Layer_B);
				ISDBT_GetLayerOutBitRate(&u4a_OutRate[VTS_ISDB_T_Layer_C], VTS_ISDB_T_Layer_C);

				CString str = gc_File.GetFilePath();
				if(!str.GetLength())				
					_tprintf(_T("No File is opened\r\n"));					
				else
				{				
					_tprintf(_T("%s\r\n"), str);
					_tprintf(_T("Mode : %d\r\n"), t_Config.mu1_Mode);
					_tprintf(_T("Guardinterval : %s\r\n"), tchGuardinterval[t_Config.mu1_Mode]);
					for (int i=0; i<3; i++)
					{
						if (ta_Param[i].mu1_segment != 0)
						{
							_tprintf(_T("---- %s ----\r\n"), tchLayer[i]);
							_tprintf(_T("Segment : %d\r\n"), ta_Param[i].mu1_segment);
							_tprintf(_T("Constellation : %s\r\n"), tchMapping[ta_Param[i].mu1_Modulation - 1]);
							_tprintf(_T("Code rate : %s\r\n"), tchCodeRate[ta_Param[i].mu1_CodeRate]);
							_tprintf(_T("Interleaving length : %d\r\n"), u1a_IntrlBase[ta_Param[i].mu1_TimeIntrlLength] << (3 - t_Config.mu1_Mode));
							_tprintf(_T("Source bit rate : %d(Bps)\r\n"), u4a_SrcBitRate[i]);
							_tprintf(_T("Out bit rate : %d(Bps)\r\n\r\n"), u4a_OutRate[i]);
						}
						else
							_tprintf(_T("%s is not used...\r\n"), tchLayer[i]);
					}
				}
			}
			else if(strcmp(s1a_CmdStr, "cmmb") == 0)	/*Initial and parsing*/
			{
				bool b_IsCmmb;
				gs4_CmmbSyncError = 0;
				
				CMMB_Initial();
				CMMB_IsCMMB_TS_W(gc_File.GetFilePath().GetBuffer(), &b_IsCmmb);
				if (b_IsCmmb == false)				
					printf(" This stream is not supported!\r\n");
				else
				{					
					CmmbClchCheck_t t_ClchCheck;
					
					unsigned int u4_Offset;
					unsigned int u4_Size;
					t_ClchCheck = CMMB_PARSING_W(gc_File.GetFilePath().GetBuffer(), &gb_IsMultiCh, &u4_Offset, &u4_Size);
					CmmbCheckClch(t_ClchCheck);
					gs4_CmmbOffSet = (int)u4_Offset;
					gs4_CmmbFrameSize = (int)u4_Size;
					gc_File.Seek(gs4_CmmbOffSet, CFile::begin);	
					printf("OK!\r\n");
				}				
			}
			else if(strcmp(s1a_CmdStr, "cmmb-show") == 0)
			{
				CmmbConfig_t t_Config;
				CMMB_GetConfig(&t_Config);
				CmmbShowConfig(t_Config);
			}
			else if(strcmp(s1a_CmdStr, "c-mode") == 0)
			{
				VTS_DVB_C_Constel_t t_Constel;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					IF_ERROR_PRINT(t_Return = DVB_C_SetConstel((VTS_DVB_C_Constel_t)u4_Temp1));
					break;
				default:
					IF_ERROR_PRINT(t_Return = DVB_C_GetConstel(&t_Constel));
					printf("\r\n %d = QAM Mode\r\n", t_Constel);
					printf("\r\nUsage: c-mode [Constellation(0/1/2/3/4 = 16/32/64/128/256 QAM)]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "c-bps") == 0)
			{
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_Return = DVB_C_SetBitRate(u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				default:
					t_Return = DVB_C_GetBitRate(&u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n Data Rate = %d bps\r\n", u4_Temp1);
						printf("\r\n Usage: c-bps [Data Rate in bps]\r\n");
					}
					break;
				}
			}
			else if(strcmp(s1a_CmdStr, "b-mode") == 0)
			{
				VTS_QAM_B_Constel_t t_Constel;
				VTS_QAM_B_Interleaving_t t_Interleaving;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d", &u4_Temp1, &u4_Temp2);

				switch(s2_ParamRead)
				{
				case 2:
					IF_ERROR_PRINT(t_Return = QAM_B_SetMode((VTS_QAM_B_Constel_t)u4_Temp1, (VTS_QAM_B_Interleaving_t)u4_Temp2));
					break;
				default:
					IF_ERROR_PRINT(t_Return = QAM_B_GetMode(&t_Constel, &t_Interleaving));
					printf("\r\n 0x%04X = QAM Mode\r\n", t_Constel);
					printf("0x%04X = Control word\r\n", t_Interleaving);

					printf("\r\nUsage: b-mode [Constellation(2/4 = 64/256 QAM)][Interleaving(3/5/7/9/1/2/4/6/8/A/C/E = I64_J2/I32_J4/I16_J8/I8_J16/I128_J1/I128_J2/I128_J3/I128_J4/I128_J5/I128_J6/I128_J7/I128_J8)]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "b-bps") == 0)
			{
				t_Return = QAM_B_GetBitRate(&u4_Temp1);
				if(t_Return != VTS_SUCCESS)
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
				{
					printf("\r\n Data Rate = %d bps\r\n", u4_Temp1);
					printf("\r\n Usage: b-bps\r\n");
				}
			}
			else if(strcmp(s1a_CmdStr, "b-bw") == 0)
			{
				t_Return = QAM_B_GetBandWidth(&u4_Temp1);
				if(t_Return != VTS_SUCCESS)
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
				{
					printf("\r\n Bandwidth = %d Hz\r\n", u4_Temp1);
					printf("\r\n Usage: b-bps\r\n");
				}
			}
			else if(strcmp(s1a_CmdStr, "cw-level") == 0)
			{
				unsigned short u2_Value;
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Temp1);

				switch(s2_ParamRead)
				{
				case 1:
					t_Return = CW_SetLevelCtrl(u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				default:
					t_Return = CW_GetLevelCtrl(&u2_Value);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n CW Level Control Value = %d\r\n", u2_Value);
						printf("\r\n Usage: cw-level [CW Level Control Value]\r\n");
					}
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "cw-20dbm") == 0)
			{
				t_Return = CW_SetLevel_20dBm();
				if(t_Return != VTS_SUCCESS)
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
					printf("OK!\r\n");
			}

			else if(strcmp(s1a_CmdStr, "f-close") == 0)
			{
				gc_File.GetStatus(gc_FileStatus);
				if(gc_FileStatus.m_atime != NULL) gc_File.Close();
			}

			else if(strcmp(s1a_CmdStr, "f-open") == 0 )
			{
				CFile c_File;
				CFileStatus c_FileStatus;
				CString c_StrFilePath;
				char s1a_FilePath[CLI_INPUT_STR_LENGTH];

				s2_ParamRead = sscanf_s(s1p_ParamStr, "%s", s1a_FilePath, sizeof(s1a_FilePath));

				gc_File.GetStatus(gc_FileStatus);
				if(gc_FileStatus.m_atime != NULL) gc_File.Close();

				switch(s2_ParamRead)
				{
				case 1:
					c_StrFilePath = s1a_FilePath;
					if(!gc_File.Open(c_StrFilePath, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone))
					{
						printf("File open error!!\r\n");
					}
					else
					{
						gu8_file_length = gc_File.GetLength();
						break;
					}
				default:
					c_StrFilePath = _T("");

					CFileDialog c_Dlg(TRUE,
									_T("ts"),
									c_StrFilePath,
									OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
									_T("TS File(*.ts)|*.ts|TRP File(*.trp)|*.trp|T-DMB File  (*.eti)|*.eti|all files(*.*)|*.*|")); 
					
					if (c_Dlg.DoModal() == IDOK)
					{
						c_StrFilePath = c_Dlg.GetPathName();
					}
					else
					{
						printf("File open cancelled!!\r\n");
						break;
					}

					if(!gc_File.Open(c_StrFilePath, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone))
					{
						printf("File open error!!\r\n");
					}
					else
					{
						gu8_file_length = gc_File.GetLength();
					}
					break;
				}

			}

			else if(strcmp(s1a_CmdStr, "f-create") == 0 )
			{
				CFile c_File;
				CFileStatus c_FileStatus;
				CString c_StrFilePath;
				char s1a_FilePath[CLI_INPUT_STR_LENGTH];

				s2_ParamRead = sscanf_s(s1p_ParamStr, "%s", s1a_FilePath, sizeof(s1a_FilePath));

				gc_File.GetStatus(gc_FileStatus);
				if(gc_FileStatus.m_atime != NULL) gc_File.Close();

				switch(s2_ParamRead)
				{
				case 1:
					c_StrFilePath = s1a_FilePath;
					if(!gc_File.Open(c_StrFilePath, CFile::modeWrite | CFile::typeBinary 
												| CFile::modeCreate  | CFile::shareDenyWrite))
					{
						printf("File open error!!\r\n");
					}
					else
					{
						gu8_file_length = gc_File.GetLength();
						break;
					}
				default:
					c_StrFilePath = _T("");

					CFileDialog c_Dlg(TRUE,
									_T("ts"),
									c_StrFilePath,
									OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
									_T("TS File(*.ts)|*.ts|TRP File(*.trp)|*.trp|T-DMB File  (*.eti)|*.eti|all files(*.*)|*.*|")); 
					
					if (c_Dlg.DoModal() == IDOK)
					{
						c_StrFilePath = c_Dlg.GetPathName();
					}
					else
					{
						printf("File open cancelled!!\r\n");
						break;
					}

					if(!gc_File.Open(c_StrFilePath, CFile::modeWrite | CFile::typeBinary 
												| CFile::modeCreate  | CFile::shareDenyWrite))
					{
						printf("File open error!!\r\n");
					}
					else
					{
						gu8_file_length = gc_File.GetLength();
					}

					break;
				}
			}

			//Attenuator
			else if(strcmp(s1a_CmdStr, "aoutput") == 0 || strcmp(s1a_CmdStr, "ao") == 0)
			{
				ULONG u4_Output;
				SHORT s2_Output;
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_Output);
				s2_Output = (SHORT)u4_Output;
				if(s2_ParamRead == 1)
				{
					t_Return = AttenSetOutLevel(s2_Output);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("OK!\r\n");
					}
				}
				else
				{
					t_Return = AttenGetOutLevel(&s2_Output);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n%d * 0.1dBm\r\n", s2_Output);
						printf("Usage: ao [Output Level in 0.1dBm]\r\n");
					}
				}

			}

			else if(strcmp(s1a_CmdStr, "afreq") == 0 || strcmp(s1a_CmdStr, "af") == 0)
			{
				unsigned int u4_Freq;
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %u", &u4_Freq);

				if(s2_ParamRead == 1)
				{
					t_Return = AttenSetFrequency(u4_Freq);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("OK!\r\n");
					}
				}
				else
				{
					t_Return = AttenGetFrequency(&u4_Freq);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n%uHz\r\n", u4_Freq);
						printf("Usage: af [Output Frequency in Hz]\r\n");
					}
				}
			}

			else if(strcmp(s1a_CmdStr, "aswitch") == 0 || strcmp(s1a_CmdStr, "as") == 0)
			{
				unsigned char u1_OnOff;
				unsigned int u4_OnOff;
				s1p_ParamStr = gs1a_InputStr + strlen(s1a_CmdStr);
				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d", &u4_OnOff);
				u1_OnOff = (unsigned char)u4_OnOff;

				if(s2_ParamRead == 1)
				{
					t_Return = AttenSetOutSwitch(u1_OnOff);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("OK!\r\n");
					}
				}
				else
				{
					t_Return = AttenGetOutSwitch(&u1_OnOff);

					if(t_Return != VTS_SUCCESS) 
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("%d = On/Off(1/0) Status\r\n", u1_OnOff);
						printf("Usage: as [Output Switch On, Off = 1, 0]\r\n");
					}
				}
			}

			else if(strcmp(s1a_CmdStr, "atemp") == 0 || strcmp(s1a_CmdStr, "at") == 0)
			{
				char s1_Tempe;
				t_Return = AttenGetTemperature(&s1_Tempe);
				if(t_Return != VTS_SUCCESS) 
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
				{
					printf("%d = Attenuator Temperature in Celsius\r\n", s1_Tempe);
				}
			}

			// User EEPROM, Read/Write 1 Byte
			else if(strcmp(s1a_CmdStr, "eep1") == 0)
			{
				int s4_Base;
				unsigned char u1_Data;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d", &s4_Base, &u4_Temp1);
				u1_Data = u4_Temp1;

				if(s4_Base > 1023) s4_Base = 1023;
				if(s4_Base < 0) s4_Base = 0;

				switch(s2_ParamRead)
				{
				case 2:
					t_Return = EEPROM_SaveUserData(s4_Base, &u1_Data, 1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				case 1:
					t_Return = EEPROM_LoadUserData(s4_Base, &u1_Data, 1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n 0x%08X @ 0x%02X(%d) \r\n", s4_Base, u1_Data, u1_Data);
					}
					break;
				default:
					printf("\r\n Usage: eep1 <Address (0~1023)> [Data 1 byte(0~255)]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "eep4") == 0)
			{
				int s4_Base;
				int s4_Data;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d", &s4_Base, &s4_Data);

				if(s4_Base > 1023) s4_Base = 1023;
				if(s4_Base < 0) s4_Base = 0;

				switch(s2_ParamRead)
				{
				case 2:
					t_Return = EEPROM_SaveUserData(s4_Base, (unsigned char*)&s4_Data, 4);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
						printf("OK!\r\n");
					break;
				case 1:
					t_Return = EEPROM_LoadUserData(s4_Base, (unsigned char*)&s4_Data, 4);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n 0x%08X @ 0x%08X(%d) \r\n", s4_Base, s4_Data, s4_Data);
					}
					break;
				default:
					printf("\r\n Usage: eep4 <Address (0~1023)> [Data 4 byte]\r\n");
					break;
				}
			}

			else if(strcmp(s1a_CmdStr, "eep-dump") == 0)
			{
				unsigned char u1a_Buff[1024];
				int s4_Base, s4_Offset, s4_Size;

				s2_ParamRead = sscanf_s(s1p_ParamStr, " %d %d", &s4_Base, &s4_Size);

				switch(s2_ParamRead)
				{
				case 2:
					break;
				case 1:
					s4_Size = 256;
				default:
					s4_Base = 0;
					s4_Size = 256;
					break;
				}

				// Parameter check
				if(s4_Size > 1024) s4_Size = 1024;
				if(s4_Size < 0) s4_Size = 1;
				if(s4_Base > 1024 - s4_Size) s4_Base = 1024 - s4_Size;

				printf("EEPROM Dump!\r\n");
				printf("Reading EEPROM, Please Wait!\r\n");

				IF_ERROR_PRINT(EEPROM_LoadUserData(s4_Base, u1a_Buff, s4_Size));

				for(s4_Offset = 0; s4_Offset < s4_Size;s4_Offset++)
				{
					if((s4_Offset % 16) == 0)
						printf("\r\n 0x%08X:",s4_Base + s4_Offset);
					printf(" %02X", u1a_Buff[s4_Offset]);
				}
				printf("\r\n Usage: eep-dump [Address (0~1023)] [Size(1~1024)]\r\n");
			}
			else
			{
				printf("Invalid Command!\r\n");
			}

			u2_KeyCount = 0;
			gs1a_InputStr[u2_KeyCount] = '\0';
		}

		else if(s1_CharIn == 0x08 || s1_CharIn == 0x7F) // Back Space & DEL
		{ 
			if(u2_KeyCount != 0)
			{
				gs1a_InputStr[--u2_KeyCount] = ' ';
				PrintCommandLine();
				gs1a_InputStr[u2_KeyCount] = '\0';
			}
			else
			{
				//nothing to do
			}
		}

		else if(s1_CharIn == (char)0x00 || s1_CharIn == (char)0xE0)
		{ 
			s1_CharIn = _getch();

			t_Return = ModulatorGetRF(&u4_Temp1);
			if(t_Return != VTS_SUCCESS)
				printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
			else
			{
				switch((unsigned char)s1_CharIn)
				{
				case 0x3B: //F1
					u4_Temp1 -= 100000000;
					break;
				case 0x3C: //F2
					u4_Temp1 += 100000000;
					break;
				case 0x3D: //F3
					u4_Temp1 -= 10000000;
					break;
				case 0x3E: //F4
					u4_Temp1 += 10000000;
					break;
				case 0x3F: //F5
					u4_Temp1 -= 1000000;
					break;
				case 0x40: //F6
					u4_Temp1 += 1000000;
					break;
				case 0x41: //F7
					u4_Temp1 -= 10000;
					break;
				case 0x42: //F8
					u4_Temp1 += 10000;
					break;
				case 0x43: //F9
					u4_Temp1 -= 100;
					break;
				case 0x44: //F10
					u4_Temp1 += 100;
					break;
				case 0x85: //F11
					u4_Temp1 -= 1;
					break;
				case 0x86: //F12
					u4_Temp1 += 1;
					break;
				default:
					break;
				}

				t_Return = ModulatorSetRF(u4_Temp1);
				if(t_Return != VTS_SUCCESS)
					printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
				else
				{
					t_Return = ModulatorGetRF(&u4_Temp1);
					if(t_Return != VTS_SUCCESS)
						printf("Command Fail: ERROR = 0x%08X \r\n", t_Return);
					else
					{
						printf("\r\n%d Hz\r\n", u4_Temp1);
					}
				}
			}
		}

		else if(s1_CharIn >= ' ' && s1_CharIn <= '~') // only for readerble characters
		{
			gs1a_InputStr[u2_KeyCount++] = s1_CharIn;
			if(u2_KeyCount > CLI_INPUT_STR_LENGTH)
			{
				u2_KeyCount--;
			}
			gs1a_InputStr[u2_KeyCount] = '\0';
		}
		else
		{
			//nothing to do
		}
	}
	else
	{
		//nothing to do
	}
}

/////////////////////////////////////////////////////////////////////////////
// The one and only application object
//CWinApp theApp;
using namespace std;
int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{

	VtsAPI_Initialize();

	if(argc == 1)
		gen_ModeType = MODE_COMMAND;
	else if(argc == 2)
	{
		_wfopen_s(&g_stream, argv[1], _T("r"));

		if(g_stream != NULL)
		{
			gen_ModeType = MODE_FILE;
			printf("\r\n*** Start script ***\r\n");
		}
		else
		{
			USES_CONVERSION;

			printf("Can NOT open script file [%s]\r\n", W2A(argv[1]));
			Sleep(2*1000);
			
			gen_ModeType = MODE_COMMAND;
		}
	}
	else
	{
		printf("Wrong command");
		Sleep(2*1000);
		
		gen_ModeType = MODE_COMMAND;
	}

	VTS_Return_t t_Return = VTS_SUCCESS;

	printf("\n");
	printf(""__FUNCTION__"(): %d %s\n",__LINE__,__FILE__);
	printf(" - Welcome to Ventus Test application ("__DATE__" "__TIME__") \n");
	printf(" - LUMANTEK, Inc. (http://www.lumantek.com/) \n");
	printf(" - VENTUS API(VtsAPI) \n");
	printf("\n");
	printf("Simple user-mode interface to command Ventus1.0:\n");
	printf(" - To close app, click 'X' in corner\n");
	printf("\n");
	//printf("%s\r\n", GetApiVersionString());

	// To Use CFileDialog
	if(AfxWinInit(GetModuleHandle(NULL),NULL,GetCommandLine(),0)==FALSE)
	{  
		cout<<"Unable to initialize MFC"<<endl; 
	}

	///////////////////////////////////////////////////////////////////////////
	// Set up a windowless window
	WNDCLASSEX RpciWindowClass = 
	{
		sizeof(WNDCLASSEX),             // UINT       cbSize; 
		0,                              // UINT       style; 
		&RpciWndProc,                   // WNDPROC    lpfnWndProc; 
		0,                              // int        cbClsExtra; 
		0,                              // int        cbWndExtra; 
		NULL,                           // HINSTANCE  hInstance; 
		NULL,                           // HICON      hIcon; 
		NULL,                           // HCURSOR    hCursor; 
		NULL,                           // HBRUSH     hbrBackground; 
		NULL,                           // LPCTSTR    lpszMenuName; 
		RpciClassName,                  // LPCTSTR    lpszClassName; 
		NULL                            // HICON      hIconSm; 
	};
	if (!RegisterClassEx(&RpciWindowClass))
	{
		return printf("_tmain(): RegisterClassEx(): ");
	}

	HWND hGhostWnd = CreateWindowEx(
		0,                          // DWORD dwExStyle,      // extended window style
		RpciClassName,              // LPCTSTR lpClassName,  // registered class name
		_T("Test"),                     // LPCTSTR lpWindowName, // window name
		0,                          // DWORD dwStyle,        // window style
		0,                          // int x,                // horizontal position of window
		0,                          // int y,                // vertical position of window
		0,                          // int nWidth,           // window width
		0,                          // int nHeight,          // window height
		NULL,                       // HWND hWndParent,      // handle to parent or owner window
		NULL,                       // HMENU hMenu,          // menu handle or child identifier
		::GetModuleHandle(NULL),                       // HINSTANCE hInstance,  // handle to application instance
		NULL                        // LPVOID lpParam        // window-creation data
	);
	if (hGhostWnd == NULL)
	{
		return printf("_tmain(): CreateWindowEx(): ");
	}

	///////////////////////////////////////////////////////////////////////////
	// Set up USB hot Plug and Play (device notification)
	DEV_BROADCAST_DEVICEINTERFACE filter;
	filter.dbcc_size = sizeof(filter);
	filter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;    //XXXXXX Consider DBT_DEVTYP_OEM? -- Darn: No GUID!
	filter.dbcc_classguid = GUID_CLASS_VENTUS10;

	HDEVNOTIFY hDevPnp = RegisterDeviceNotification(
		hGhostWnd,                      // HANDLE hRecipient,
		&filter,                        // LPVOID NotificationFilter,
		DEVICE_NOTIFY_WINDOW_HANDLE     // DWORD Flags
	);
	if (hDevPnp == INVALID_HANDLE_VALUE)
	{
		printf("_tmain(): RegisterDeviceNotification(): failed!! \n");
		return ERROR_GEN_FAILURE;
	}

	while (TRUE)
	{
		MSG Msg;
		if (PeekMessage (&Msg, NULL, 0, 0, PM_REMOVE))
			IsDialogMessage(hGhostWnd, &Msg);

		PrintCommandLine();
		CLI_Process();
		DataProcess();
	}

	IF_ERROR_PRINT(t_Return = CloseDevice());

	VtsAPI_Finalize();
	///////////////////////////////////////////////////////////////////////////
	// Cleanup
	return NO_ERROR;
}
void CmmbCheckClch(CmmbClchCheck_t t_ClchCheck)
{
	TCHAR ClchMsg[] = _T("%s is not default value of CLCH!!\r\n");
	TCHAR ClchSetMsg[] = _T("Do you apply default parameter of CLCH? (y/n) : ");
	CmmbInformation_t t_Parameter;

	t_Parameter.mt_BandWidth = CMMB_8MH;
	t_Parameter.mt_IntrlMod = CMMB_INTRL_MOD1;
	t_Parameter.mt_Lpdc = CMMB_LDPC_1_2;
	t_Parameter.mt_Modulation = CMMB_QNST_BPSK;
	t_Parameter.mt_Rs = CMMB_RS_240;
	t_Parameter.mt_Scramble = CMMB_SCR_MOD0;
	t_Parameter.mu1_TimeSlotN = 1;
	const TCHAR Comp = 'y';

	if (t_ClchCheck.b_ConstCheck == true)
	{
		TCHAR temp;
		_tprintf(ClchMsg, _T("Constellation"));
		_tprintf(ClchSetMsg);
		_tscanf_s(_T("%c"), &temp, sizeof(TCHAR));fflush(stdin);
		if(temp == Comp)
			CMMB_ChangeParameter(0, t_Parameter);
	}
	if (t_ClchCheck.b_LdpcCheck == true)
	{
		TCHAR temp;
		_tprintf(ClchMsg, _T("LDPC"));
		_tprintf(ClchSetMsg);
		_tscanf_s(_T("%c"), &temp, sizeof(TCHAR));fflush(stdin);
		if(temp == Comp)
			CMMB_ChangeParameter(0, t_Parameter);
	}
	if (t_ClchCheck.b_ScrambleCheck == true)
	{
		TCHAR temp = 0;
		_tprintf(ClchMsg, _T("Mode of Scramble"));
		_tprintf(ClchSetMsg);
		_tscanf_s(_T("%c"), &temp, sizeof(TCHAR));fflush(stdin);
		if(temp == Comp)
			CMMB_ChangeParameter(0, t_Parameter);
	}
	if (t_ClchCheck.b_RsCheck == true)
	{
		TCHAR temp;
		_tprintf(ClchMsg, _T("RS"));
		_tprintf(ClchSetMsg);
		_tscanf_s(_T("%c"), &temp, sizeof(TCHAR));fflush(stdin);
		if(temp == Comp)
			CMMB_ChangeParameter(0, t_Parameter);
	}
	if (t_ClchCheck.b_TimeSlotCheck == true)
	{
		TCHAR temp;
		_tprintf(ClchMsg, _T("The number of time slot"));
		_tprintf(ClchSetMsg);
		_tscanf_s(_T("%c"), &temp, sizeof(TCHAR));fflush(stdin);
		if(temp == Comp)
			CMMB_ChangeParameter(0, t_Parameter);
	}
}
void CmmbShowConfig(CmmbConfig_t t_Config)
{
	if(t_Config.mb_IsTs == true)
		printf("Stream type	: TS format!\r\n");
	else if(gb_IsMultiCh == true)
		printf("Stream type	: Multi-MFS!\r\n");
	else
		printf("Stream type	: Single-MFS!\r\n");	
	printf("Total PLCH	: %d!\r\n", t_Config.ms4_FrameN);
}
///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
