
// VentusTest4Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "VentusTest4.h"
#include "VentusTest4Dlg.h"

#include "VtsAPI.h"

#include "common.h"


//if bit rate is zero
#define BITRATE_ZERO_MARKER _T("---.-")

//if Not used item
#define NOT_USED_ITEM _T("---")

//Timer
#define TIMER_ID_PLAY_TIME 100
#define TIMER_PLAY_TIME    10


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

//*********************************************************
//*******************Global value**************************
//*********************************************************
CVtsAPI gc_VtsAPI;

VTSCC_t gt_VtsCC;
VTSCC_t gt_VtsCCget;
//VTSCF_t gt_VtsCF;
VTSUC_t gt_VtsUC;
VTSUF_t gt_VtsUF;

CVentusTest4Dlg* gp_MainDlg;

bool g_isThread     = true;
bool g_isDeviceOpen = false;
bool g_isOpenInFile  = false;
bool g_isOpenDSL = true;


UINT  gu4_ReadSize;	
UINT  gu4_FileReadBytes;
ULONG gu4_TransferedBytes;
UCHAR gu1a_Buff[DATA_BUFFER_LENGTH];

CFile g_InFile;
CFile g_OutFile;



//*********************************************************
//****************Function For Thread**********************
//*********************************************************
VOID SLEEP(volatile unsigned int u4_ms) 
{ 
	Sleep(u4_ms); 
}

inline HRESULT OpenFileCommon(VOID)
{
	HRESULT hResult(S_OK);

	if(g_InFile.Open(gt_VtsCC.strInFilePathName, CFile::modeRead|CFile::shareDenyNone) == NULL)
	{
		AfxMessageBox(_T("Cannot open file"));

		return hResult = S_FALSE;
	}

	return hResult;
}

inline HRESULT OpenFileTDMB(VOID)
{
	HRESULT hResult(S_OK);

	if(g_InFile.Open(gt_VtsCC.strInFilePathName, CFile::modeRead|CFile::shareDenyNone) == NULL)
	{
		AfxMessageBox(_T("Cannot open file"));

		return hResult = S_FALSE;
	}

	UCHAR Buff[CVtsAPI::WRITE_SIZE_ETI*100];
	ZeroMemory(Buff, CVtsAPI::WRITE_SIZE_ETI*100);

	g_InFile.Read(Buff, CVtsAPI::WRITE_SIZE_ETI*100);

	if(gc_VtsAPI.T_DMB_Parse(Buff, CVtsAPI::WRITE_SIZE_ETI*100, g_isOpenDSL) != VTS_SUCCESS) 
	{
		CString str;
		str.Format(_T("%s file is not ETI file, Please select ETI file again"), gt_VtsCC.strInFilePathName);
		AfxMessageBox(str);
		gt_VtsCC.strInFilePathName = _T("");
		return hResult = S_FALSE;
	}

	gc_VtsAPI.T_DMB_GetBitRate(&gt_VtsUC.u4_TDMB_SrcBitRate_bps);	
	gc_VtsAPI.T_DMB_GetBufferOffset(&gt_VtsUC.s4_OffSetSourceFile);	
	gc_VtsAPI.T_DMB_GetMode(&gt_VtsUC.s4_TDMB_TM);

	g_InFile.Seek(gt_VtsUC.s4_OffSetSourceFile, CFile::begin);

	gp_MainDlg->PostMessage(VTS_MSG_TDMB_TM_MODE);

	return hResult;
}

inline HRESULT OpenFileCMMB(VOID)
{
	HRESULT hResult(S_OK);

	bool isCMMb = false;
	gc_VtsAPI.CMMB_IsCMMB_TS(gt_VtsCC.strInFilePathName, &isCMMb);

	if(isCMMb != true)
		return hResult = S_FALSE;

	if(g_InFile.Open(gt_VtsCC.strInFilePathName, CFile::modeRead|CFile::shareDenyNone) == NULL)
	{
		AfxMessageBox(_T("Cannot open file"));

		return hResult = S_FALSE;
	}

	//Init CMMB
	gc_VtsAPI.CMMB_Initial();

	//Parsing file
	CmmbClchCheck_t t_Return;
	UINT OffSet = gt_VtsUC.s4_OffSetSourceFile;
	t_Return = gc_VtsAPI.CMMB_PARSING(gt_VtsCC.strInFilePathName, &gt_VtsUC.isCMMB_MultiCH, 
		                              &OffSet, &gt_VtsUC.u4_CMMB_FrameSize);	
	gt_VtsUC.s4_OffSetSourceFile = OffSet;


	//Check CLCH 
	if(t_Return.b_RsCheck || t_Return.b_LdpcCheck || t_Return.b_ConstCheck || t_Return.b_ScrambleCheck || t_Return.b_TimeSlotCheck)
	{
		//Not Standard CLCH, 
		AfxMessageBox(_T("CLCH is not Standard"));
	}

	//Get CMMB Information
	gc_VtsAPI.CMMB_GetConfig(&gt_VtsCCget.t_CMMB_Config);
	gt_VtsCC.t_CMMB_Config = gt_VtsCCget.t_CMMB_Config;	

	//Check Frame Size
	if(gt_VtsUC.isCMMB_MultiCH)	
		gu4_ReadSize = gt_VtsUC.u4_CMMB_FrameSize;	
	else
		gu4_ReadSize = gt_VtsCC.t_CMMB_Config.mt_Lch[2].ms4_FileFrameSize;

	//If has not padding bit(0xFF)
	bool isPadding(false);
	if(gt_VtsUC.isCMMB_MultiCH)
		isPadding = gt_VtsCCget.t_CMMB_Config.mb_Is0xFFpadding;
	else
		isPadding = gt_VtsCCget.t_CMMB_Config.mt_Lch[2].mb_IsFramePadding;

	if(isPadding == false)
		AfxMessageBox(_T("Has not padding bit"));

	//Get CMMB Source bitrate
	gt_VtsUC.u4_CMMB_SrcBitRate_bps = 0;
	for(INT i = 0; i < gt_VtsCC.t_CMMB_Config.ms4_FrameN; i++)
		gt_VtsUC.u4_CMMB_SrcBitRate_bps += gt_VtsCC.t_CMMB_Config.mt_Lch[i].mt_SourceBps.mu4_Total;	

	gt_VtsCC.u4_SourceRate_bps = gt_VtsUC.u4_CMMB_SrcBitRate_bps;	

	//Get CMMB Out bitrate
	gc_VtsAPI.CMMB_GetOutBitRate(&gt_VtsUC.u4_CMMB_OutBitRate_bps);
	gp_MainDlg->PostMessage(VTS_MSG_CMMB_OUT_BITRATE);

	//Seek to begin point
	g_InFile.Seek(gt_VtsUC.s4_OffSetSourceFile, CFile::begin);


	g_isOpenInFile = true;


	return hResult;
}

//***********************************************************************
//That must be initialized parameter value of each modulator, before use.
//***********************************************************************
inline VOID InitDVB_TH_Param(VOID)
{
	gc_VtsAPI.DVB_TH_SetBandWidth(gt_VtsCC.u1_DVBTH_BW_MHz);
	gc_VtsAPI.DVB_TH_SetCellID(gt_VtsCC.u2_DVBTH_CellID);			
	gc_VtsAPI.DVB_TH_SetMode(
		gt_VtsCC.isDVBTH_CellID,
		gt_VtsCC.t_DVBTH_Interleaver,
		gt_VtsCC.isDVBTH_UseMPE_FEC,
		gt_VtsCC.isDVBTH_UseTimeSlicing,
		gt_VtsCC.isDVBTH_HEnable,
		gt_VtsCC.t_DVBTH_GuardInt,
		gt_VtsCC.t_DVBTH_TxMode,
		gt_VtsCC.t_DVBTH_Constel,
		gt_VtsCC.t_DVBTH_CodeRate);
}

inline VOID ChangeParamCW(VOID)
{
	if(gt_VtsCC.isCW_Level_20dBm)
	{
		gt_VtsCC.u2_CW_LevelCtrl = gc_VtsAPI.CW_GetLevelCtrl_20dBm();
		gt_VtsCC.isCW_Level_20dBm = false;
	}

	if(gt_VtsCC.u2_CW_LevelCtrl != gt_VtsCCget.u2_CW_LevelCtrl)
	{
		if(gc_VtsAPI.CW_SetLevelCtrl(gt_VtsCC.u2_CW_LevelCtrl) == VTS_SUCCESS)
			gc_VtsAPI.CW_GetLevelCtrl(&gt_VtsCCget.u2_CW_LevelCtrl);

		if(gt_VtsCCget.u2_CW_LevelCtrl == gc_VtsAPI.CW_GetLevelCtrl_20dBm())
			gt_VtsCCget.isCW_Level_20dBm = true;
		else
			gt_VtsCCget.isCW_Level_20dBm = false;

	}
}

inline VOID ChangeParamDVB_TH(VOID)
{
	//Change BandWidth
	if(gt_VtsCC.u1_DVBTH_BW_MHz != gt_VtsCCget.u1_DVBTH_BW_MHz)
	{
		if(gc_VtsAPI.DVB_TH_SetBandWidth(gt_VtsCC.u1_DVBTH_BW_MHz) == VTS_SUCCESS)
		{
			gc_VtsAPI.DVB_TH_GetBandWidth(&gt_VtsCCget.u1_DVBTH_BW_MHz);

			if(gt_VtsCC.u1_DVBTH_BW_MHz == gt_VtsCCget.u1_DVBTH_BW_MHz)
			{
				gc_VtsAPI.DVB_TH_GetSymRate(&gt_VtsUC.u4_DVBTH_SymRate_bd);

				gp_MainDlg->PostMessage(VTS_MSG_DVB_TH_SYMBOL_RATE);
			}
		}
	}

	//Change Code rate
	if(gt_VtsCC.t_DVBTH_CodeRate != gt_VtsCCget.t_DVBTH_CodeRate)
	{
		if(gc_VtsAPI.DVB_TH_SetCodeRate(gt_VtsCC.t_DVBTH_CodeRate) == VTS_SUCCESS)
		{
			gc_VtsAPI.DVB_TH_GetCodeRate(&gt_VtsCCget.t_DVBTH_CodeRate);

			if(gt_VtsCC.t_DVBTH_CodeRate == gt_VtsCCget.t_DVBTH_CodeRate)			
				gt_VtsUF.isDVBTH_BitRate_bps = true;			
		}
	}

	//Change Constellation
	if(gt_VtsCC.t_DVBTH_Constel != gt_VtsCCget.t_DVBTH_Constel)
	{
		if(gc_VtsAPI.DVB_TH_SetConstel(gt_VtsCC.t_DVBTH_Constel) == VTS_SUCCESS)
		{
			gc_VtsAPI.DVB_TH_GetConstel(&gt_VtsCCget.t_DVBTH_Constel);

			if(gt_VtsCC.t_DVBTH_Constel == gt_VtsCCget.t_DVBTH_Constel)
				gt_VtsUF.isDVBTH_BitRate_bps = true;	
		}
	}

	//Change IFFT/Mode	
	if(gt_VtsCC.t_DVBTH_TxMode != gt_VtsCCget.t_DVBTH_TxMode)
	{
		if(gc_VtsAPI.DVB_TH_SetTxMode(gt_VtsCC.t_DVBTH_TxMode) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetTxMode(&gt_VtsCCget.t_DVBTH_TxMode);
	}

	//Change Guard Interval
	if(gt_VtsCC.t_DVBTH_GuardInt != gt_VtsCCget.t_DVBTH_GuardInt)
	{
		if(gc_VtsAPI.DVB_TH_SetGuardInt(gt_VtsCC.t_DVBTH_GuardInt) == VTS_SUCCESS)
		{
			gc_VtsAPI.DVB_TH_GetGuardInt(&gt_VtsCCget.t_DVBTH_GuardInt);

			if(gt_VtsCC.t_DVBTH_GuardInt == gt_VtsCCget.t_DVBTH_GuardInt)
				gt_VtsUF.isDVBTH_BitRate_bps = true;	
		}
	}

	if(gt_VtsUF.isDVBTH_BitRate_bps == true)
	{
		gt_VtsUF.isDVBTH_BitRate_bps = false;
		gc_VtsAPI.DVB_TH_GetBitRate(&gt_VtsUC.u4_DVBTH_BitRate_bps);

		gp_MainDlg->PostMessage(VTS_MSG_DVB_TH_OUT_BITRATE);
	}

//Change for additional parameters

	//Change Inner Interleaver
	if(gt_VtsCC.t_DVBTH_Interleaver != gt_VtsCCget.t_DVBTH_Interleaver)
	{
		if(gc_VtsAPI.DVB_TH_SetInterleaver(gt_VtsCC.t_DVBTH_Interleaver) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetInterleaver(&gt_VtsCCget.t_DVBTH_Interleaver);
	}

	//Enable/Disable Cell ID
	if(gt_VtsCC.isDVBTH_CellID != gt_VtsCCget.isDVBTH_CellID)
	{
		if(gc_VtsAPI.DVB_TH_SetCellIDEn(gt_VtsCC.isDVBTH_CellID) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetCellIDEn(&gt_VtsCCget.isDVBTH_CellID);
	}

	//Change Cell ID
	if(gt_VtsCC.u2_DVBTH_CellID != gt_VtsCCget.u2_DVBTH_CellID)
	{
		if(gc_VtsAPI.DVB_TH_SetCellID(gt_VtsCC.u2_DVBTH_CellID) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetCellID(&gt_VtsCCget.u2_DVBTH_CellID);
	}

	//Enable/Disable S48, S49 Setting
	if(gt_VtsCC.isDVBTH_HEnable != gt_VtsCCget.isDVBTH_HEnable)
	{
		if(gc_VtsAPI.DVB_TH_SetDVBHEnable(gt_VtsCC.isDVBTH_HEnable) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetDVBHEnable(&gt_VtsCCget.isDVBTH_HEnable);
	}

	//0 : No Time Slicing, 1 : Time Slicing
	if(gt_VtsCC.isDVBTH_UseTimeSlicing != gt_VtsCCget.isDVBTH_UseTimeSlicing)
	{
		if(gc_VtsAPI.DVB_TH_SetTimeSlicing(gt_VtsCC.isDVBTH_UseTimeSlicing) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetTimeSlicing(&gt_VtsCCget.isDVBTH_UseTimeSlicing);
	}

	//0 : No MPE-FEC, 1 : MPE-FEC
	if(gt_VtsCC.isDVBTH_UseMPE_FEC != gt_VtsCCget.isDVBTH_UseMPE_FEC)
	{
		if(gc_VtsAPI.DVB_TH_SetMPE_FEC(gt_VtsCCget.isDVBTH_UseMPE_FEC) == VTS_SUCCESS)
			gc_VtsAPI.DVB_TH_GetMPE_FEC(&gt_VtsCCget.isDVBTH_UseMPE_FEC);
	}
}

VOID ControlProcess(VOID)
{
	//Change Broadcast Type
	if(gt_VtsCC.t_BcType != gt_VtsCCget.t_BcType)
	{
		if(gc_VtsAPI.ModulatorInit(gt_VtsCC.t_BcType) == VTS_SUCCESS)
		{
			gc_VtsAPI.ModulatorGetBcType(&gt_VtsCCget.t_BcType);

			if(gt_VtsCC.t_BcType == gt_VtsCCget.t_BcType)
			{
				AfxMessageBox(_T("Changed BcType"));

				//Init DVB-TH Parameters
				switch (gt_VtsCCget.t_BcType)
				{
				case VTS_BC_CW:     break;
				case VTS_BC_DVB_S:	break;
				case VTS_BC_DVB_S2:	break;
				case VTS_BC_DVB_T:  
				case VTS_BC_DVB_H:  InitDVB_TH_Param(); break;	
				case VTS_BC_DVB_C:  break;
				case VTS_BC_ATSC:	break;
				case VTS_BC_QAM_B:	break;
				case VTS_BC_QAM_C:	break;
				case VTS_BC_ISDB_T:	gu4_ReadSize = gt_VtsUC.s4_ISDBT_FrameSize; break;
				case VTS_BC_T_DMB:	gu4_ReadSize = CVtsAPI::WRITE_SIZE_ETI; break;
				case VTS_BC_DTMB:	break;
				case VTS_BC_CMMB:	break;
				}

				// Read Write Size
				if(gt_VtsCCget.t_BcType != VTS_BC_T_DMB && gt_VtsCCget.t_BcType != VTS_BC_ISDB_T)
					gu4_ReadSize = CVtsAPI::WRITE_SIZE_TS;

				gp_MainDlg->PostMessage(VTS_MSG_CHANGE_BC_TYPE);
			}
		}
	}

	//Change Pump Mode
	if(gt_VtsCC.t_PumpMode != gt_VtsCCget.t_PumpMode)
	{
		if(gc_VtsAPI.PumpSetMode(gt_VtsCC.t_PumpMode, gt_VtsCCget.u4_isRemux, gt_VtsCCget.t_OutTsFormat, gt_VtsCCget.t_SrcTsFormat) == VTS_SUCCESS)
		{
			gc_VtsAPI.PumpGetMode(&gt_VtsCCget.t_PumpMode, &gt_VtsCCget.u4_isRemux, &gt_VtsCCget.t_OutTsFormat, &gt_VtsCCget.t_SrcTsFormat);

			if(gt_VtsCC.t_PumpMode == gt_VtsCCget.t_PumpMode)
				AfxMessageBox(_T("Changed PumpMode"));
		}
	}

	//Change ReMux state
	if(gt_VtsCC.u4_isRemux != gt_VtsCCget.u4_isRemux)
	{
		if(gc_VtsAPI.PumpSetMode(gt_VtsCCget.t_PumpMode, gt_VtsCC.u4_isRemux, gt_VtsCCget.t_OutTsFormat, gt_VtsCCget.t_SrcTsFormat) == VTS_SUCCESS)
			gc_VtsAPI.PumpGetMode(&gt_VtsCCget.t_PumpMode, &gt_VtsCCget.u4_isRemux, &gt_VtsCCget.t_OutTsFormat, &gt_VtsCCget.t_SrcTsFormat);
	}

	//Change Out TS Format
	if(gt_VtsCC.t_OutTsFormat != gt_VtsCCget.t_OutTsFormat)
	{
		if(gc_VtsAPI.PumpSetMode(gt_VtsCCget.t_PumpMode, gt_VtsCCget.u4_isRemux, gt_VtsCC.t_OutTsFormat, gt_VtsCCget.t_SrcTsFormat) == VTS_SUCCESS)
			gc_VtsAPI.PumpGetMode(&gt_VtsCCget.t_PumpMode, &gt_VtsCCget.u4_isRemux, &gt_VtsCCget.t_OutTsFormat, &gt_VtsCCget.t_SrcTsFormat);
	}

	//Change Source TS Format
	if(gt_VtsCC.t_SrcTsFormat != gt_VtsCCget.t_SrcTsFormat)
	{
		if(gc_VtsAPI.PumpSetMode(gt_VtsCCget.t_PumpMode, gt_VtsCCget.u4_isRemux, gt_VtsCCget.t_OutTsFormat, gt_VtsCC.t_SrcTsFormat) == VTS_SUCCESS)
			gc_VtsAPI.PumpGetMode(&gt_VtsCCget.t_PumpMode, &gt_VtsCCget.u4_isRemux, &gt_VtsCCget.t_OutTsFormat, &gt_VtsCCget.t_SrcTsFormat);
	}

	//Change Source bit rate
	if(gt_VtsCC.u4_SourceRate_bps != gt_VtsCCget.u4_SourceRate_bps)
	{
		if(gc_VtsAPI.PumpSetRawRate(gt_VtsCC.u4_SourceRate_bps) == VTS_SUCCESS)
		{
			gc_VtsAPI.PumpGetRawRate(&gt_VtsCCget.u4_SourceRate_bps);

			if(gt_VtsCC.u4_SourceRate_bps == gt_VtsCCget.u4_SourceRate_bps)
				gp_MainDlg->PostMessage(VTS_MSG_SOURCE_BITRATE);
		}
	}

	//Change Conversion rate when Pump-Mode is ASI-OUT
	if(gt_VtsCCget.t_PumpMode == VTS_PUMP_MODE_ASI_OUT && gt_VtsCC.u4_ASI_OUT_OutRate_bps != gt_VtsCCget.u4_ASI_OUT_OutRate_bps)
	{
		if(gc_VtsAPI.PumpSetConvRate(gt_VtsCC.u4_ASI_OUT_OutRate_bps) == VTS_SUCCESS)
			gc_VtsAPI.PumpGetConvRate(&gt_VtsCCget.u4_ASI_OUT_OutRate_bps);
	}

	//Change Frequency (50MHz ~ 870MHz)
	if(gt_VtsCC.u4_Frequency_hz != gt_VtsCCget.u4_Frequency_hz)
	{
		gc_VtsAPI.ModulatorSetRF(gt_VtsCC.u4_Frequency_hz);
		gc_VtsAPI.ModulatorGetRF(&gt_VtsCCget.u4_Frequency_hz);

		gt_VtsCC.u4_AttenFreq_Hz = gt_VtsCCget.u4_Frequency_hz;
	}

	//Change Parameter of Atten-Plus when Atten-Plus is exist
	if(gt_VtsUC.isExistAttenPlus)
	{
		//Change level
		if(gt_VtsCC.s2_Level_01dBm != gt_VtsCCget.s2_Level_01dBm)
		{
			if(gc_VtsAPI.AttenSetOutLevel(gt_VtsCC.s2_Level_01dBm) == VTS_SUCCESS)
				gc_VtsAPI.AttenGetOutLevel(&gt_VtsCCget.s2_Level_01dBm);
		}

		//Switching level
		if(gt_VtsCC.u1_OnOffAttenPlus != gt_VtsCCget.u1_OnOffAttenPlus)
		{
			if(gc_VtsAPI.AttenSetOutSwitch(gt_VtsCC.u1_OnOffAttenPlus) == VTS_SUCCESS)
				gc_VtsAPI.AttenGetOutSwitch(&gt_VtsCCget.u1_OnOffAttenPlus);
		}

		if(gt_VtsCC.u4_AttenFreq_Hz != gt_VtsCC.u4_AttenFreq_Hz)
		{	
			gc_VtsAPI.AttenSetFrequency(gt_VtsCC.u4_AttenFreq_Hz);
			gc_VtsAPI.AttenGetFrequency(&gt_VtsCCget.u4_AttenFreq_Hz);			
		}
	}

	//Change Parameter of each Modulator
	switch (gt_VtsCCget.t_BcType)
	{
	case VTS_BC_CW:    ChangeParamCW(); break;
	case VTS_BC_DVB_S:	break;
	case VTS_BC_DVB_S2:	break;
	case VTS_BC_DVB_T:
	case VTS_BC_DVB_H: ChangeParamDVB_TH(); break;	
	case VTS_BC_DVB_C:
		{

		}
		break;
	case VTS_BC_ATSC:
		{

		}
		break;
	case VTS_BC_QAM_B:
		{

		}
		break;
	case VTS_BC_QAM_C:
		{

		}
		break;
	case VTS_BC_ISDB_T:
		{

		}
		break;
	case VTS_BC_T_DMB:
		{

		}
		break;
	case VTS_BC_DTMB:
		{

		}
		break;
	case VTS_BC_CMMB:
		{

		}
		break;
	}

	//Change Pump State
	if(gt_VtsCC.t_PumpState != gt_VtsCCget.t_PumpState)
	{
		if(gc_VtsAPI.PumpSetState(gt_VtsCC.t_PumpState) == VTS_SUCCESS)
		{
			gc_VtsAPI.PumpGetState(&gt_VtsCCget.t_PumpState);

			//Process File OffSet
			if(gt_VtsCCget.t_PumpState == VTS_PUMP_STATE_STOP_CLR)
			{

			}
		}
	}

}

VOID DataProcess(VOID)
{
	if(gt_VtsCC.strInFilePathName != gt_VtsCCget.strInFilePathName)
	{
		HRESULT hResult(S_FALSE);

		if(g_isOpenInFile == true)
			g_InFile.Close();


		
		CString strExt = gt_VtsCC.strInFilePathName.Right(3);
		if(strExt.CompareNoCase(_T("DSL")) == 0)
			g_isOpenDSL = true;
		else
			g_isOpenDSL = false;

		switch(gt_VtsCCget.t_BcType)
		{
		case VTS_BC_CW: 	break;
		case VTS_BC_DVB_S:	break;
		case VTS_BC_DVB_S2:	break;
		case VTS_BC_DVB_T:	
		case VTS_BC_DVB_H:  	
		case VTS_BC_DVB_C:	
		case VTS_BC_ATSC:	
		case VTS_BC_QAM_B:	hResult = OpenFileCommon(); break;
		case VTS_BC_QAM_C:	break;
		case VTS_BC_ISDB_T:	break;
		case VTS_BC_T_DMB:	hResult = OpenFileTDMB(); break;
		case VTS_BC_DTMB:	break;
		case VTS_BC_CMMB:   hResult = OpenFileCMMB(); break;
		}

		if(hResult == S_OK)
		{
			gt_VtsCCget.strInFilePathName = gt_VtsCC.strInFilePathName;
			g_isOpenInFile = true;
		}
		else
			gt_VtsCC.strInFilePathName = gt_VtsCCget.strInFilePathName;
		
	}

	gc_VtsAPI.PumpGetHwBuffUsed(&gt_VtsUC.u4_HwBufferUsed);

	if((gt_VtsCCget.t_PumpMode == VTS_PUMP_MODE_ASI_OUT ||
		gt_VtsCCget.t_PumpMode == VTS_PUMP_MODE_RF_OUT ||
		gt_VtsCCget.t_PumpMode == VTS_PUMP_MODE_RF_OUT_RAW) &&	// Pump Mode Check
		gt_VtsCCget.t_PumpState == VTS_PUMP_STATE_RUN &&		// Pump State Check
		g_isOpenInFile)          								// File Open Check
			
	{	
		//////////////////////////////////////////////////////////////////////////
		//Check free space of buffer
		if(gt_VtsCCget.t_BcType == VTS_BC_T_DMB)
		{
			if(gt_VtsUC.u4_HwBufferUsed > (gt_VtsUC.u4_HwBufferSize - gu4_ReadSize*100))
			{
				SLEEP(200);
				return;
			}
		}
		else if(gt_VtsCCget.t_BcType == VTS_BC_CMMB)
		{
			if(gt_VtsUC.u4_HwBufferUsed > (gt_VtsUC.u4_HwBufferSize - gu4_ReadSize))
			{
				SLEEP(10);
				return;
			}
		}
		else
		{
			if(gt_VtsUC.u4_HwBufferUsed > (gt_VtsUC.u4_HwBufferSize - gu4_ReadSize))
			{
				SLEEP(200);
				return;
			}
		}
		//Check free space of buffer
		//////////////////////////////////////////////////////////////////////////
		

		if(gt_VtsCCget.t_BcType != VTS_BC_CMMB)
		{
			gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);

			if(gu4_FileReadBytes != gu4_ReadSize)
				g_InFile.Seek(gt_VtsUC.s4_OffSetSourceFile, CFile::begin);
		}
		else
		{	
			int s4_NewFrameSize = 0;
			unsigned char u1_MfId = 2;
			bool b_IsPadding;
			CmmbConfig_t t_Config = gt_VtsCC.t_CMMB_Config;

			if (gt_VtsUC.isCMMB_MultiCH == false)		
				b_IsPadding = t_Config.mt_Lch[u1_MfId].mb_IsFramePadding;		
			else		
				b_IsPadding = t_Config.mb_Is0xFFpadding;

			gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);	

			if(b_IsPadding == false)
			{					
				ULONGLONG u8_FilePosition = g_InFile.GetPosition();

				s4_NewFrameSize = gc_VtsAPI.CMMB_CheckMfSize(gt_VtsUC.isCMMB_MultiCH, u1_MfId, gu1a_Buff);
				if((gu4_FileReadBytes != s4_NewFrameSize) && (u8_FilePosition != g_InFile.GetLength()))
				{
					g_InFile.Seek(-((int)gu4_FileReadBytes), CFile::current);
					gu4_ReadSize = s4_NewFrameSize;
					gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);									
				}
			}	

			//seek to begin with offset
			if(gu4_FileReadBytes != gu4_ReadSize)
			{
				g_InFile.Seek(gt_VtsUC.s4_OffSetSourceFile, CFile::begin);		
				gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);
				
				if(b_IsPadding == false)
				{								
					s4_NewFrameSize = gc_VtsAPI.CMMB_CheckMfSize(gt_VtsUC.isCMMB_MultiCH, u1_MfId, gu1a_Buff);
					if(gu4_FileReadBytes != s4_NewFrameSize)
					{
						g_InFile.Seek(-((int)gu4_FileReadBytes), CFile::current);
						gu4_ReadSize = s4_NewFrameSize;
						gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);									
					}
					
					gc_VtsAPI.CMMB_GetConfig(&t_Config);
				}
			}

			//check Sync	
			int s4_CmmbOffSet;
			int s4_CmmbFrameSize;
			if(gc_VtsAPI.CMMB_CHECK_SYNC( g_InFile.GetFilePath().GetBuffer(), g_InFile.GetPosition(), &s4_CmmbOffSet, &s4_CmmbFrameSize, gt_VtsUC.isCMMB_MultiCH,
				                          gt_VtsCC.t_CMMB_Config, gu1a_Buff) != VTS_SUCCESS	)
			{
				if(s4_CmmbOffSet < 0)
				{
#ifdef _DEBUG
					AfxMessageBox(_T("OffSet Error!"));
#endif
				}
				else
					g_InFile.Seek(s4_CmmbOffSet, CFile::current);

				gu4_FileReadBytes = g_InFile.Read(gu1a_Buff, gu4_ReadSize);					
			}		
		}


		gc_VtsAPI.PumpWrite(gu1a_Buff, gu4_FileReadBytes, &gu4_TransferedBytes, g_isOpenDSL);

		INT iDiffer = static_cast<INT>(gu4_TransferedBytes - gu4_FileReadBytes);	
		
		if(iDiffer != 0)
			g_InFile.Seek(iDiffer, CFile::current);

		
	}
		
}

UINT ThreadMain(LPVOID pv_Param)
{
	gp_MainDlg = static_cast<CVentusTest4Dlg*>(pv_Param);

	while(g_isThread)
	{
		if(!g_isDeviceOpen)
		{
			SLEEP(300);
			continue;
		}

		ControlProcess();
		DataProcess();
	}

	return 0;
}



// CVentusTest4Dlg dialog

CVentusTest4Dlg::CVentusTest4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVentusTest4Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//time items
	mu4_TotalTime_milli = 0;
	mu4_TotalTime_Sec = 0;
	mu4_TotalTime_Min = 0;
	mu4_TotalTime_Hou = 0;
	mu8_TestTime = 0;
}

void CVentusTest4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_CW, m_checkCW);
}

BEGIN_MESSAGE_MAP(CVentusTest4Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_OOPEN_VENTUS, &CVentusTest4Dlg::OnBnClickedButtonOpenVentus)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, &CVentusTest4Dlg::OnBnClickedButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, &CVentusTest4Dlg::OnBnClickedButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CVentusTest4Dlg::OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_RECORD, &CVentusTest4Dlg::OnBnClickedButtonRecord)
	ON_BN_CLICKED(IDC_RADIO_DVB_2K_8K, &CVentusTest4Dlg::OnBnClickedRadioDvb2k8k)
	ON_BN_CLICKED(IDC_RADIO_DVB_4K, &CVentusTest4Dlg::OnBnClickedRadioDvb4k)
	ON_BN_CLICKED(IDC_RADIO_DVB_C, &CVentusTest4Dlg::OnBnClickedRadioDvbC)
	ON_BN_CLICKED(IDC_RADIO_OPENCABLE, &CVentusTest4Dlg::OnBnClickedRadioOpencable)
	ON_BN_CLICKED(IDC_RADIO_ATSC, &CVentusTest4Dlg::OnBnClickedRadioAtsc)
	ON_BN_CLICKED(IDC_RADIO_ISDB_TB, &CVentusTest4Dlg::OnBnClickedRadioIsdbTb)
	ON_BN_CLICKED(IDC_RADIO_CMMB, &CVentusTest4Dlg::OnBnClickedRadioCmmb)
	ON_BN_CLICKED(IDC_CHECK_CW, &CVentusTest4Dlg::OnBnClickedCheckCw)
	ON_BN_CLICKED(IDC_RADIO_ASI_OUT, &CVentusTest4Dlg::OnBnClickedRadioAsiOut)
	ON_BN_CLICKED(IDC_RADIO_ASI_IN, &CVentusTest4Dlg::OnBnClickedRadioAsiIn)
	ON_BN_CLICKED(IDC_RADIO_RF_OUT, &CVentusTest4Dlg::OnBnClickedRadioRfOut)
	ON_BN_CLICKED(IDC_RADIO_ASI_RF, &CVentusTest4Dlg::OnBnClickedRadioAsiRf)
	ON_BN_CLICKED(IDC_RADIO_RF_OUT_RAW, &CVentusTest4Dlg::OnBnClickedRadioRfOutRaw)
	ON_BN_CLICKED(IDC_RADIO_TDMB, &CVentusTest4Dlg::OnBnClickedRadioTdmb)
	ON_CBN_SELCHANGE(IDC_COMBO_CODE_RATE, &CVentusTest4Dlg::OnCbnSelchangeComboCodeRate)
	ON_CBN_SELCHANGE(IDC_COMBO_CONSTELLATION, &CVentusTest4Dlg::OnCbnSelchangeComboConstellation)
	ON_CBN_SELCHANGE(IDC_COMBO_IFFT, &CVentusTest4Dlg::OnCbnSelchangeComboIfft)
	ON_CBN_SELCHANGE(IDC_COMBO_OUT_TS_TYPE, &CVentusTest4Dlg::OnCbnSelchangeComboOutTsType)
	ON_CBN_SELCHANGE(IDC_COMBO_SOURCE_TS_TYPE, &CVentusTest4Dlg::OnCbnSelchangeComboSourceTsType)
	ON_CBN_SELCHANGE(IDC_COMBO_GUARD_INTERVAL, &CVentusTest4Dlg::OnCbnSelchangeComboGuardInterval)
	ON_CBN_SELCHANGE(IDC_COMBO_INTERLEAVER, &CVentusTest4Dlg::OnCbnSelchangeComboInterleaver)
	ON_CBN_SELCHANGE(IDC_COMBO_BW, &CVentusTest4Dlg::OnCbnSelchangeComboBw)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_REMUX, &CVentusTest4Dlg::OnBnClickedCheckRemux)
	ON_BN_CLICKED(IDC_BUTTON2, &CVentusTest4Dlg::OnBnClickedButton2)

	ON_MESSAGE(VTS_MSG_CHANGE_BC_TYPE, &CVentusTest4Dlg::OnChangeBcType)
	ON_MESSAGE(VTS_MSG_SOURCE_BITRATE, &CVentusTest4Dlg::OnSourceBitRate)
	ON_MESSAGE(VTS_MSG_DVB_TH_OUT_BITRATE, &CVentusTest4Dlg::OnDVB_TH_OutBitRate)
	ON_MESSAGE(VTS_MSG_DVB_TH_SYMBOL_RATE, &CVentusTest4Dlg::OnDVB_TH_SymbolRate)
	ON_MESSAGE(VTS_MSG_CMMB_OUT_BITRATE, &CVentusTest4Dlg::OnCMMB_OutBitRate)
	ON_MESSAGE(VTS_MSG_TDMB_TM_MODE, &CVentusTest4Dlg::OnTDMB_TM_Mode)
	
	
	ON_EN_KILLFOCUS(IDC_EDIT_SOURCE_RATE, &CVentusTest4Dlg::OnEnKillfocusEditSourceRate)
	ON_EN_KILLFOCUS(IDC_EDIT_OUT_RATE, &CVentusTest4Dlg::OnEnKillfocusEditOutRate)
	ON_EN_KILLFOCUS(IDC_EDIT_SYMBOL_RATE, &CVentusTest4Dlg::OnEnKillfocusEditSymbolRate)
	ON_EN_KILLFOCUS(IDC_EDIT_FREQUENCY, &CVentusTest4Dlg::OnEnKillfocusEditFrequency)
	ON_EN_KILLFOCUS(IDC_EDIT_LEVEL, &CVentusTest4Dlg::OnEnKillfocusEditLevel)
END_MESSAGE_MAP()


// CVentusTest4Dlg message handlers

BOOL CVentusTest4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);

		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	mp_ThreadHandle = AfxBeginThread(ThreadMain, this);	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVentusTest4Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVentusTest4Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVentusTest4Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CVentusTest4Dlg::OnBnClickedButtonOpenVentus()
{
	// TODO: Add your control notification handler code here

	int s4_NumOfVentus = gc_VtsAPI.CountDevice();

	if(s4_NumOfVentus == 0)
	{
		AfxMessageBox(_T("Ventus is not the connection."));
		return;
	}	
	
	if(gc_VtsAPI.OpenDevice(0) == VTS_SUCCESS)
	{
		g_isDeviceOpen = true;
		gc_VtsAPI.SkyBandGetExistence();
		AfxMessageBox(_T("Ventus was opened."));
	}
	else
	{
		AfxMessageBox(_T("Error!\nPlease, check cable."));
		return;
	}

	//Check Supported BC-Type
	VTS_Return_t t_Return = VTS_SUCCESS;
	for(int s4_Index = VTS_BC_CW; s4_Index < VTS_BC_MAX; s4_Index++)
	{
		VTS_BroadcastType_t t_BcType;
		t_BcType = (VTS_BroadcastType_t)s4_Index;
		t_Return = gc_VtsAPI.PumpGetBcTypeSupport(t_BcType);
		if(t_Return == VTS_SUCCESS)
			gt_VtsUC.isBcTypeSupport[t_BcType] = TRUE;
		else
			gt_VtsUC.isBcTypeSupport[t_BcType] = FALSE;
	}

	//Get HW Buffer Size
	gc_VtsAPI.PumpGetHwBuffSize(&gt_VtsUC.u4_HwBufferSize);

	//Check Atten-Plus
	gc_VtsAPI.AttenGetID(&gt_VtsUC.t_AttenuatorID);
	gt_VtsUC.isExistAttenPlus = gc_VtsAPI.AttenGetExistence();

}

BOOL CVentusTest4Dlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		switch (pMsg->wParam)
		{
		case VK_ESCAPE:
			{
				return TRUE;
			}
			break;
		case VK_RETURN:
			{
				if(GetFocus() == GetDlgItem(IDC_EDIT_SOURCE_RATE))
				{
					CString strSrcBitRate;
					GetDlgItem(IDC_EDIT_SOURCE_RATE)->GetWindowText(strSrcBitRate);

					gt_VtsCC.u4_SourceRate_bps = _wtoi(strSrcBitRate);
				}
				else if(GetFocus() == GetDlgItem(IDC_EDIT_FREQUENCY))
				{
					CString strFreq;
					GetDlgItem(IDC_EDIT_FREQUENCY)->GetWindowText(strFreq);

					gt_VtsCC.u4_Frequency_hz = (unsigned int)(_wtof(strFreq) + 0.5);

				}
				else if(GetFocus() == GetDlgItem(IDC_EDIT_LEVEL))
				{
					CString strLevel;
					GetDlgItem(IDC_EDIT_LEVEL)->GetWindowText(strLevel);

					gt_VtsCC.s2_Level_01dBm = _wtoi(strLevel)*10;
				}


				return TRUE;
			}
			break;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CVentusTest4Dlg::OnBnClickedButtonOpen()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE);

	if(dlg.DoModal() == IDOK)
	{
		gt_VtsCC.strInFilePathName = dlg.GetPathName();
		
		GetDlgItem(IDC_STATIC_PATH)->SetWindowText(dlg.GetPathName());
	}
}

void CVentusTest4Dlg::OnBnClickedButtonPlay()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpState = VTS_PUMP_STATE_RUN;

	SetTimer(TIMER_ID_PLAY_TIME, TIMER_PLAY_TIME, NULL);
}

void CVentusTest4Dlg::OnBnClickedButtonStop()
{
	// TODO: Add your control notification handler code here

	KillTimer(TIMER_ID_PLAY_TIME);

	gt_VtsCC.t_PumpState = VTS_PUMP_STATE_STOP;

	//time items
	mu4_TotalTime_milli = 0;
	mu4_TotalTime_Sec = 0;
	mu4_TotalTime_Min = 0;
	mu4_TotalTime_Hou = 0;
	mu8_TestTime = 0;
}

void CVentusTest4Dlg::OnBnClickedButtonRecord()
{
	// TODO: Add your control notification handler code here
}

void CVentusTest4Dlg::OnBnClickedRadioDvb2k8k()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_DVB_T;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioDvb4k()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_DVB_H;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioDvbC()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_DVB_C;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioTdmb()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_T_DMB;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioOpencable()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_QAM_B;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioAtsc()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_ATSC;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioIsdbTb()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_ISDB_T;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioCmmb()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_BcType = VTS_BC_CMMB;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedCheckCw()
{
	// TODO: Add your control notification handler code here
	if(m_checkCW.GetCheck() == BST_CHECKED)
		gt_VtsCC.isCW_Level_20dBm = true;
	else	
		gt_VtsCC.u2_CW_LevelCtrl = 0;
}

void CVentusTest4Dlg::OnBnClickedCheckRemux()
{
	// TODO: Add your control notification handler code here
	if(static_cast<CButton*>(GetDlgItem(IDC_CHECK_REMUX))->GetCheck() == BST_CHECKED)
		gt_VtsCC.u4_isRemux = true;
	else
		gt_VtsCC.u4_isRemux = false;
}

void CVentusTest4Dlg::OnBnClickedRadioAsiOut()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpMode = VTS_PUMP_MODE_ASI_OUT;
	gt_VtsCC.t_BcType = VTS_BC_CW;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioAsiIn()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpMode = VTS_PUMP_MODE_ASI_IN;
	gt_VtsCC.t_BcType = VTS_BC_CW;

	//Update GUI of Main dialog
	UpdateGUI();
}

void CVentusTest4Dlg::OnBnClickedRadioRfOut()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpMode = VTS_PUMP_MODE_RF_OUT;
}

void CVentusTest4Dlg::OnBnClickedRadioAsiRf()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpMode = VTS_PUMP_MODE_ASI_RF;
}

void CVentusTest4Dlg::OnBnClickedRadioRfOutRaw()
{
	// TODO: Add your control notification handler code here
	gt_VtsCC.t_PumpMode = VTS_PUMP_MODE_RF_OUT_RAW;
}

void CVentusTest4Dlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	g_isThread = false;

	SLEEP(100);

	TerminateThread(mp_ThreadHandle->m_hThread, INFINITE);

	gc_VtsAPI.CloseDevice();


	CDialog::OnCancel();
}

VOID CVentusTest4Dlg::InitComboCtrl(CComboBox* pCombo, CWnd* pWnd, BOOL isEnable)
{
	if(pCombo == NULL)
		pCombo = static_cast<CComboBox*>(pWnd);

	pCombo->EnableWindow(isEnable);
	pCombo->ResetContent();
	pCombo->InsertString(0, NOT_USED_ITEM);
	pCombo->SetCurSel(0);	
}

VOID CVentusTest4Dlg::UpdateGUI( VOID )
{
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_CODE_RATE), FALSE);
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_CONSTELLATION), FALSE);
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_IFFT), FALSE);	
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_OUT_TS_TYPE), FALSE);	
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE), FALSE);	
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_BW), FALSE);
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_INTERLEAVER), FALSE);
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_GUARD_INTERVAL), FALSE);
	InitComboCtrl(NULL, GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE), FALSE);

	GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_OUT_RATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_SYMBOL_RATE)->EnableWindow(FALSE);

	m_checkCW.EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(FALSE);

	switch(gt_VtsCC.t_BcType)
	{
	case VTS_BC_CW: 	
		{
			m_checkCW.EnableWindow(TRUE);	

			GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDIT_OUT_RATE)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(TRUE);
		}
		break;
	case VTS_BC_DVB_S:	break;
	case VTS_BC_DVB_S2:	break;
	case VTS_BC_DVB_T:	
	case VTS_BC_DVB_H:  
		{
			//Enable controls
			GetDlgItem(IDC_COMBO_CODE_RATE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_IFFT)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_CONSTELLATION)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_OUT_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_BW)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_GUARD_INTERVAL)->EnableWindow(TRUE);		

			GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(TRUE);			
			GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(TRUE);


			//Insert code rate item
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->ResetContent();
			CString strCodeRate[] = {_T("1/2"), _T("2/3"), _T("3/4"), _T("5/6"), _T("7/8")};
			for(INT i = 0; i < 5; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->InsertString(i, strCodeRate[i]);

			//Insert IFFT Item	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->ResetContent();
			if(gt_VtsCC.t_BcType == VTS_BC_DVB_T)
			{						
				CString strIFFT[] = {_T("2K"), _T("8K")};
				for(INT i = 0; i < 2; i++)
					static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->InsertString(i, strIFFT[i]);
			}
			else
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->InsertString(0, _T("4K"));
			}		

			//Insert item of Source/Out ts format	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			CString strTsFormat[] = {_T("188"), _T("204")};
			for(INT i = 0; i < 2; i++)
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(i, strTsFormat[i]);
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(i, strTsFormat[i]);
			}

			//Insert Constellation Type			
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->ResetContent();
			CString strConstel[] = {_T("QPSK"), _T("16QAM"), _T("64QAM")};
			for(INT i = 0; i < 3; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->InsertString(i, strConstel[i]);

			//Insert bandwidth	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->ResetContent();
			CString strBW[] = {_T("5 MHz"), _T("6 MHz"), _T("7 MHz"), _T("8 MHz"),};
			for(INT i = 0; i < 4; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->InsertString(i, strBW[i]);
				
			//Insert item of guard interval		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->ResetContent();
			CString strGuardInt[] = {_T("1/32"), _T("1/16"), _T("1/8"), _T("1/4")};
			for(INT i = 0; i < 4; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->InsertString(i, strGuardInt[i]);			
		}
		break;
	case VTS_BC_DVB_C:	
		{
			//Enable controls
			GetDlgItem(IDC_COMBO_CONSTELLATION)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_OUT_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE)->EnableWindow(TRUE);

			GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(TRUE);		
			GetDlgItem(IDC_EDIT_SYMBOL_RATE)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(TRUE);


			//Insert Constellation Type		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->ResetContent();
			CString strConstel[] = {_T("QPSK"), _T("16QAM"), _T("64QAM")};
			for(INT i = 0; i < 3; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->InsertString(i, strConstel[i]);

			//Insert item of Source/Out ts format	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			CString strTsFormat[] = {_T("188"), _T("204")};
			for(INT i = 0; i < 2; i++)
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(i, strTsFormat[i]);
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(i, strTsFormat[i]);
			}
		}
		break;
	case VTS_BC_ATSC:	
		{
			//Enable controls
			GetDlgItem(IDC_COMBO_OUT_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE)->EnableWindow(TRUE);

			GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(TRUE);		
			GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(TRUE);

			//Insert Constellation
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->InsertString(0, _T("8-VSB"));

			//Insert BW
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->InsertString(0, _T("6 MHz"));

			//Insert item of Source/Out ts format		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			CString strTsFormat[] = {_T("188"), _T("204")};
			for(INT i = 0; i < 2; i++)
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(i, strTsFormat[i]);
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(i, strTsFormat[i]);
			}
		}
		break;
	case VTS_BC_QAM_B:	
		{
			//Enable controls
			GetDlgItem(IDC_COMBO_INTERLEAVER)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_CONSTELLATION)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_OUT_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE)->EnableWindow(TRUE);

			GetDlgItem(IDC_EDIT_SOURCE_RATE)->EnableWindow(TRUE);			
			GetDlgItem(IDC_CHECK_REMUX)->EnableWindow(TRUE);

			//Insert Constellation Type		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->ResetContent();
			CString strConstel[] = {_T("64QAM"), _T("256QAM")};
			for(INT i = 0; i < 2; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->InsertString(i, strConstel[i]);

			//Insert item of interleaver		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_INTERLEAVER))->ResetContent();
			CString strIJ[] = {_T("I=128, J=1"), _T("I=128, J=2"), _T("I=64,   J=2"), _T("I=128, J=3"), _T("I=32,   J=4"), 
				_T("I=128, J=4"), _T("I=16,   J=8"), _T("I=128, J=5"), _T("I=8,     J=16"), _T("I=128, J=6"), 
				_T("I=128, J=7")/*Index 12*/, _T("I=128, J=8")/*Index 14*/};

			for(INT i = 0; i < 12; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_INTERLEAVER))->InsertString(i, strIJ[i]);

			//Insert item of Source/Out ts format		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			CString strTsFormat[] = {_T("188"), _T("204")};
			for(INT i = 0; i < 2; i++)
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(i, strTsFormat[i]);
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(i, strTsFormat[i]);
			}
				
		}
		break;
	case VTS_BC_QAM_C:	break;
	case VTS_BC_ISDB_T:	
		{
			//Enable controls
			GetDlgItem(IDC_COMBO_CODE_RATE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_IFFT)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_CONSTELLATION)->EnableWindow(TRUE);			
			GetDlgItem(IDC_COMBO_GUARD_INTERVAL)->EnableWindow(TRUE);	
			GetDlgItem(IDC_COMBO_OUT_TS_TYPE)->EnableWindow(TRUE);
			GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE)->EnableWindow(TRUE);

			//Insert item of code rate			
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->ResetContent();
			CString strCodeRate[] = {_T("1/2"), _T("2/3"), _T("3/4"), _T("5/6"), _T("7/8")};
			for(INT i = 0; i < 5; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->InsertString(i, strCodeRate[i]);

			//Insert item of constellation	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->ResetContent();
			CString strConst[] = {_T("QPSK"), _T("16QAM"), _T("64QAM")};			
			for(INT i = 0; i < 3; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->InsertString(i, strConst[i]);

			//Insert item of IFFT		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->ResetContent();
			CString strIFFT[] = {_T("2K"), _T("4K"), _T("8K")};
			for(INT i = 0; i < 3; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->InsertString(i, strIFFT[i]);

			//Insert item of Source/Out ts format	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			CString strTsFormat[] = {_T("188"), _T("204")};
			for(INT i = 0; i < 2; i++)
			{
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(i, strTsFormat[i]);
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(i, strTsFormat[i]);
			}

			//Insert item of guard interval	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->ResetContent();
			CString strGuardInt[] = {_T("1/32"), _T("1/16"), _T("1/8"), _T("1/4")};
			for(INT i = 0; i < 4; i++)
				static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->InsertString(i, strGuardInt[i]);				

			//Insert BW
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->InsertString(0, _T("6 MHz"));	
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->SetCurSel(0);
		}
		break;
	case VTS_BC_T_DMB:	
		{
			//Insert item of Source/Out ts format			
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->InsertString(0, _T("6144"));
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->SetCurSel(0);
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->InsertString(0, _T("6144"));
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->SetCurSel(0);
			

			//Insert BW
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->ResetContent();
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->InsertString(0, _T("1.536 MHz"));		
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->SetCurSel(0);			
			
		}
		break;
	case VTS_BC_DTMB:	break;
	case VTS_BC_CMMB:   break;
	}
}

VOID CVentusTest4Dlg::UpdateBcTypeRadioCtrl(VOID)
{
	GetDlgItem(IDC_RADIO_DVB_2K_8K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_DVB_4K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_DVB_C)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ATSC)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_OPENCABLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ISDB_TB)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TDMB)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_CMMB)->EnableWindow(FALSE);

	if(gt_VtsUC.isBcTypeSupport[VTS_BC_DVB_T])
		GetDlgItem(IDC_RADIO_DVB_2K_8K)->EnableWindow(TRUE);
		
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_DVB_H])
		GetDlgItem(IDC_RADIO_DVB_4K)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_DVB_C])
		GetDlgItem(IDC_RADIO_DVB_C)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_ATSC])
		GetDlgItem(IDC_RADIO_ATSC)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_QAM_B])
		GetDlgItem(IDC_RADIO_OPENCABLE)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_ISDB_T])
		GetDlgItem(IDC_RADIO_ISDB_TB)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_T_DMB])
		GetDlgItem(IDC_RADIO_TDMB)->EnableWindow(TRUE);
	
	if(gt_VtsUC.isBcTypeSupport[VTS_BC_CMMB])
		GetDlgItem(IDC_RADIO_CMMB)->EnableWindow(TRUE);



		
}

void CVentusTest4Dlg::OnCbnSelchangeComboCodeRate()
{
	// TODO: Add your control notification handler code here
	if(gt_VtsCCget.t_BcType == VTS_BC_DVB_T || gt_VtsCCget.t_BcType == VTS_BC_DVB_H)
	{
		switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->GetCurSel())
		{
		case 0: gt_VtsCC.t_DVBTH_CodeRate = VTS_DVB_TH_CODE_RATE_1_2; break;
		case 1: gt_VtsCC.t_DVBTH_CodeRate = VTS_DVB_TH_CODE_RATE_2_3; break;
		case 2: gt_VtsCC.t_DVBTH_CodeRate = VTS_DVB_TH_CODE_RATE_3_4; break;
		case 3: gt_VtsCC.t_DVBTH_CodeRate = VTS_DVB_TH_CODE_RATE_5_6; break;
		case 4: gt_VtsCC.t_DVBTH_CodeRate = VTS_DVB_TH_CODE_RATE_7_8; break;
		}
	}
}

void CVentusTest4Dlg::OnCbnSelchangeComboConstellation()
{
	// TODO: Add your control notification handler code here
	if(gt_VtsCCget.t_BcType == VTS_BC_DVB_C)
	{
		switch (static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->GetCurSel())
		{
		case 0: gt_VtsCC.t_DVBC_Constel = VTS_DVB_C_QAM16; break;
		case 1: gt_VtsCC.t_DVBC_Constel = VTS_DVB_C_QAM32; break;
		case 2: gt_VtsCC.t_DVBC_Constel = VTS_DVB_C_QAM64; break;
		case 3: gt_VtsCC.t_DVBC_Constel = VTS_DVB_C_QAM128; break;
		case 4: gt_VtsCC.t_DVBC_Constel = VTS_DVB_C_QAM256; break;
		}
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_DVB_T || gt_VtsCCget.t_BcType == VTS_BC_DVB_H) 
	{
		switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->GetCurSel())
		{
		case 0: gt_VtsCC.t_DVBTH_Constel = VTS_DVB_TH_CONSTELL_QPSK; break;
		case 1: gt_VtsCC.t_DVBTH_Constel = VTS_DVB_TH_CONSTELL_16QAM; break;
		case 2: gt_VtsCC.t_DVBTH_Constel = VTS_DVB_TH_CONSTELL_64QAM; break;
		}
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_QAM_B)
	{
		switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->GetCurSel())
		{
		case 0: gt_VtsCC.t_QAMB_Constel = VTS_QAM_B_QAM64; break;
		case 1: gt_VtsCC.t_QAMB_Constel = VTS_QAM_B_QAM256; break;
		}
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_ISDB_T)
	{
		gt_VtsCC.t_ISDBT_Layer_A_Parameter.mu1_Modulation = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->GetCurSel() + 1;
	}
}

void CVentusTest4Dlg::OnCbnSelchangeComboIfft()
{
	// TODO: Add your control notification handler code here
	if(gt_VtsCCget.t_BcType == VTS_BC_DVB_T)
	{
		switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->GetCurSel())
		{
		case 0: gt_VtsCC.t_DVBTH_TxMode = VTS_DVB_TH_TRANS_MODE_2K; break;
		case 1: gt_VtsCC.t_DVBTH_TxMode = VTS_DVB_TH_TRANS_MODE_8K; break;
		}
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_DVB_H)
	{
		gt_VtsCC.t_DVBTH_TxMode = VTS_DVB_TH_TRANS_MODE_4K;
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_ISDB_T)
	{
		gt_VtsCC.t_ISDBT_OFDM_Config.mu1_Mode = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->GetCurSel() + 1;
	}
}

void CVentusTest4Dlg::OnCbnSelchangeComboOutTsType()
{
	// TODO: Add your control notification handler code here
	if(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_OUT_TS_TYPE))->GetCurSel() == 0)	
		gt_VtsCC.t_OutTsFormat = VTS_TS_FORMAT_188;
	else
		gt_VtsCC.t_OutTsFormat = VTS_TS_FORMAT_204;	
}

void CVentusTest4Dlg::OnCbnSelchangeComboSourceTsType()
{
	// TODO: Add your control notification handler code here
	if(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_SOURCE_TS_TYPE))->GetCurSel() == 0)	
		gt_VtsCC.t_SrcTsFormat = VTS_TS_FORMAT_188;
	else
		gt_VtsCC.t_SrcTsFormat = VTS_TS_FORMAT_204;	
}

void CVentusTest4Dlg::OnCbnSelchangeComboGuardInterval()
{
	// TODO: Add your control notification handler code here
	if(gt_VtsCCget.t_BcType == VTS_BC_DVB_T || gt_VtsCCget.t_BcType == VTS_BC_DVB_H)
	{
		switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->GetCurSel())
		{
		case 0: gt_VtsCC.t_DVBTH_GuardInt = VTS_DVB_TH_GUARD_INT_1_32; break;
		case 1: gt_VtsCC.t_DVBTH_GuardInt = VTS_DVB_TH_GUARD_INT_1_16; break;
		case 2: gt_VtsCC.t_DVBTH_GuardInt = VTS_DVB_TH_GUARD_INT_1_8; break;
		case 3: gt_VtsCC.t_DVBTH_GuardInt = VTS_DVB_TH_GUARD_INT_1_4; break;
		}
	}
	else if(gt_VtsCCget.t_BcType == VTS_BC_ISDB_T)
	{
		gt_VtsCC.t_ISDBT_OFDM_Config.mu1_GuardInterval = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->GetCurSel();
	}

}

void CVentusTest4Dlg::OnCbnSelchangeComboInterleaver()
{
	// TODO: Add your control notification handler code here
	switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_INTERLEAVER))->GetCurSel())
	{
	case 0: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J1; break;
	case 1: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J2; break;
	case 2: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I64_J2; break;
	case 3: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J3; break;
	case 4: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I32_J4; break;
	case 5: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J4; break;
	case 6: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I16_J8; break;
	case 7: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J5; break;
	case 8: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I8_J16; break;
	case 9: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J6; break;
	case 10: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J7; break;
	case 11: gt_VtsCC.t_QAMB_Interleaving = VTS_QAM_B_I128_J8; break;
	}
}

void CVentusTest4Dlg::OnCbnSelchangeComboBw()
{
	// TODO: Add your control notification handler code here
	switch(static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->GetCurSel())
	{
	case 0: gt_VtsCC.u1_DVBTH_BW_MHz = 5; break;
	case 1: gt_VtsCC.u1_DVBTH_BW_MHz = 6; break;
	case 2: gt_VtsCC.u1_DVBTH_BW_MHz = 7; break;
	case 3: gt_VtsCC.u1_DVBTH_BW_MHz = 8; break;
	}
}


//*************************************************************************
//**********************MESSAGE HANDLER*********
//*************************************************************************
LRESULT CVentusTest4Dlg::OnSourceBitRate(WPARAM wParam, LPARAM lParam)
{
	CString strSrcBitRate;
	strSrcBitRate.Format(_T("%d"), gt_VtsCC.u4_SourceRate_bps);

	GetDlgItem(IDC_EDIT_SOURCE_RATE)->SetWindowText(strSrcBitRate);

	return 0;
}

LRESULT CVentusTest4Dlg::OnDVB_TH_SymbolRate( WPARAM wParam, LPARAM lParam )
{
	CString strSymbol;
	strSymbol.Format(_T("%d"), gt_VtsUC.u4_DVBTH_SymRate_bd);

	GetDlgItem(IDC_EDIT_SYMBOL_RATE)->SetWindowText(strSymbol);

	return 0;
}

LRESULT CVentusTest4Dlg::OnDVB_TH_OutBitRate( WPARAM wParam, LPARAM lParam )
{
	CString strBitRate;
	strBitRate.Format(_T("%d"), gt_VtsUC.u4_DVBTH_BitRate_bps);

	GetDlgItem(IDC_EDIT_OUT_RATE)->SetWindowText(strBitRate);

	return 0;
}

LRESULT CVentusTest4Dlg::OnCMMB_OutBitRate(WPARAM wParam, LPARAM lParam)
{
	CString strBitRate;
	strBitRate.Format(_T("%d"), gt_VtsUC.u4_CMMB_OutBitRate_bps);

	GetDlgItem(IDC_EDIT_OUT_RATE)->SetWindowText(strBitRate);

	return 0;
}
LRESULT CVentusTest4Dlg::OnTDMB_TM_Mode(WPARAM wParam, LPARAM lParam)
{
	//Insert item of Transmission mode		
	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->ResetContent();	

	switch (gt_VtsUC.s4_TDMB_TM)
	{
	case 1: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->AddString(_T("TM-1")); break;
	case 2: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->AddString(_T("TM-2")); break;
	case 3: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->AddString(_T("TM-3")); break;
	case 4: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->AddString(_T("TM-4")); break;
	}

	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->SetCurSel(0);

	return 0;
}

LRESULT CVentusTest4Dlg::OnChangeBcType( WPARAM wParam, LPARAM lParam )
{
	switch (gt_VtsCCget.t_BcType)
	{
	case VTS_BC_CW:     break;
	case VTS_BC_DVB_S:	break;
	case VTS_BC_DVB_S2:	break;
	case VTS_BC_DVB_T:  
	case VTS_BC_DVB_H:  
		{ 
			//Code Rate
			switch(gt_VtsCCget.t_DVBTH_CodeRate)
			{				
			case VTS_DVB_TH_CODE_RATE_1_2:	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->SetCurSel(0); break;
			case VTS_DVB_TH_CODE_RATE_2_3:	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->SetCurSel(1); break;
			case VTS_DVB_TH_CODE_RATE_3_4:	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->SetCurSel(2); break;
			case VTS_DVB_TH_CODE_RATE_5_6:	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->SetCurSel(3); break;
			case VTS_DVB_TH_CODE_RATE_7_8:	static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CODE_RATE))->SetCurSel(4); break;
			}

			//Constellation
			switch(gt_VtsCCget.t_DVBTH_Constel)
			{
			case VTS_DVB_TH_CONSTELL_QPSK: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->SetCurSel(0); break;
			case VTS_DVB_TH_CONSTELL_16QAM:static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->SetCurSel(1); break;
			case VTS_DVB_TH_CONSTELL_64QAM:static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_CONSTELLATION))->SetCurSel(2); break;
			}

			//IFFT
			switch(gt_VtsCCget.t_DVBTH_TxMode)
			{ 
			case VTS_DVB_TH_TRANS_MODE_2K: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->SetCurSel(0); break;
			case VTS_DVB_TH_TRANS_MODE_8K: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->SetCurSel(1); break;
			case VTS_DVB_TH_TRANS_MODE_4K: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_IFFT))->SetCurSel(0); break;
			}

			//BandWidth
			static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_BW))->SetCurSel(gt_VtsCCget.u1_DVBTH_BW_MHz-5);

			//Guard Interval
			switch(gt_VtsCCget.t_DVBTH_GuardInt)
			{
			case VTS_DVB_TH_GUARD_INT_1_32: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->SetCurSel(0); break;
			case VTS_DVB_TH_GUARD_INT_1_16: static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->SetCurSel(1); break;
			case VTS_DVB_TH_GUARD_INT_1_8:  static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->SetCurSel(2); break;
			case VTS_DVB_TH_GUARD_INT_1_4:  static_cast<CComboBox*>(GetDlgItem(IDC_COMBO_GUARD_INTERVAL))->SetCurSel(3); break;
			}
			
		}
		break;	
	case VTS_BC_DVB_C:  break;
	case VTS_BC_ATSC:	break;
	case VTS_BC_QAM_B:	break;
	case VTS_BC_QAM_C:	break;
	case VTS_BC_ISDB_T:	break;
	case VTS_BC_T_DMB:	break;
	case VTS_BC_DTMB:	break;
	case VTS_BC_CMMB:	break;
	}

	return 0;
}
void CVentusTest4Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	switch(nIDEvent)
	{
	case TIMER_ID_PLAY_TIME:
		{
			if(++mu4_TotalTime_milli > 99)
			{
				mu4_TotalTime_milli = 0;
				if(++mu4_TotalTime_Sec >= 60)
				{
					mu4_TotalTime_Sec = 0;
					if(++mu4_TotalTime_Min >= 60)
					{
						mu4_TotalTime_Min = 0;
						++mu4_TotalTime_Hou;
					}
				}
			}			

			if(mu4_TotalTime_Hou >= 10)
				m_strTotaltime_Hou.Format(_T("%d : "), mu4_TotalTime_Hou);
			else
				m_strTotaltime_Hou.Format(_T("0%d : "), mu4_TotalTime_Hou);

			if(mu4_TotalTime_Min >= 10)
				m_strTotaltime_Min.Format(_T("%d : "), mu4_TotalTime_Min);
			else
				m_strTotaltime_Min.Format(_T("0%d : "), mu4_TotalTime_Min);

			if(mu4_TotalTime_Sec >= 10)
				m_strTotaltime_Sec.Format(_T("%d : "), mu4_TotalTime_Sec);
			else
				m_strTotaltime_Sec.Format(_T("0%d : "), mu4_TotalTime_Sec);

			if(mu4_TotalTime_milli >= 10)
				m_strTotaltime_milli.Format(_T("%d"), mu4_TotalTime_milli);
			else
				m_strTotaltime_milli.Format(_T("0%d"), mu4_TotalTime_milli);


			GetDlgItem(IDC_STATIC_PLAY_TIME)->SetWindowText(m_strTotaltime_Hou+m_strTotaltime_Min+m_strTotaltime_Sec+m_strTotaltime_milli);

		}
		break;
	}

	CDialog::OnTimer(nIDEvent);
}

void CVentusTest4Dlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	if(gt_VtsCC.u1_OnOffAttenPlus == 1)
		gt_VtsCC.u1_OnOffAttenPlus = 0;
	else
		gt_VtsCC.u1_OnOffAttenPlus = 1;
}

void CVentusTest4Dlg::OnEnKillfocusEditSourceRate()
{
	// TODO: Add your control notification handler code here
	CString strSrcBitRate;
	GetDlgItem(IDC_EDIT_SOURCE_RATE)->GetWindowText(strSrcBitRate);

	gt_VtsCC.u4_SourceRate_bps = _wtoi(strSrcBitRate);
}

void CVentusTest4Dlg::OnEnKillfocusEditOutRate()
{
	// TODO: Add your control notification handler code here
	CString strSrcBitRate;
	GetDlgItem(IDC_EDIT_OUT_RATE)->GetWindowText(strSrcBitRate);

	gt_VtsCC.u4_SourceRate_bps = _wtoi(strSrcBitRate);
}

void CVentusTest4Dlg::OnEnKillfocusEditSymbolRate()
{
	// TODO: Add your control notification handler code here
	CString strSrcBitRate;
	GetDlgItem(IDC_EDIT_SYMBOL_RATE)->GetWindowText(strSrcBitRate);

	gt_VtsCC.u4_SourceRate_bps = _wtoi(strSrcBitRate);
}

void CVentusTest4Dlg::OnEnKillfocusEditFrequency()
{
	// TODO: Add your control notification handler code here
	CString strFreq;
	GetDlgItem(IDC_EDIT_FREQUENCY)->GetWindowText(strFreq);

	gt_VtsCC.u4_Frequency_hz = (unsigned int)(_wtof(strFreq) + 0.5);
}

void CVentusTest4Dlg::OnEnKillfocusEditLevel()
{
	// TODO: Add your control notification handler code here
	CString strLevel;
	GetDlgItem(IDC_EDIT_LEVEL)->GetWindowText(strLevel);

	gt_VtsCC.s2_Level_01dBm = _wtoi(strLevel)*10;
}
