/*******************************************************************************
Copyright (C) 2009, LUMANTEK Co., Ltd.,  (http://www.lumantek.com)


Sample code with VtsAPI that is C++ API for Ventus

History:
2009.02.13: Version 1.0 release

NOTE : When open the device, you will need to initialize the instances of VTSCC_t, VTSUC_t, VTSUF_t

VTS_PUMP_MODE_ASI_OUT		= 0, // Stream(File) on HDD to ASI-Out port For CW
VTS_PUMP_MODE_RF_OUT		= 1, // for DVB-x, ATSC, CW... Must use 288Ts Out-format
VTS_PUMP_MODE_ASI_IN		= 2, // Recording TS from ASI-In port For CW
VTS_PUMP_MODE_ASI_RF		= 3, // ASI-IN to RF-OUT, For DVB-x, ATSC, CW...
VTS_PUMP_MODE_RF_OUT_RAW	= 6, // for T-DMB, ISDB-T, CMMB

*******************************************************************************/

// VentusTest4Dlg.h : header file
//

#pragma once
#include "afxwin.h"

#define DATA_BUFFER_LENGTH 1024*1024*8

// CVentusTest4Dlg dialog
class CVentusTest4Dlg : public CDialog
{
// Construction
public:
	CVentusTest4Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_VENTUSTEST4_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

public:
	afx_msg void OnBnClickedButtonOpenVentus();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedButtonOpen();
	afx_msg void OnBnClickedButtonPlay();
	afx_msg void OnBnClickedButtonStop();
	afx_msg void OnBnClickedButtonRecord();
	afx_msg void OnBnClickedRadioDvb2k8k();
	afx_msg void OnBnClickedRadioDvb4k();
	afx_msg void OnBnClickedRadioDvbC();
	afx_msg void OnBnClickedRadioTdmb();
	afx_msg void OnBnClickedRadioOpencable();
	afx_msg void OnBnClickedRadioAtsc();
	afx_msg void OnBnClickedRadioIsdbTb();
	afx_msg void OnBnClickedRadioCmmb();
	afx_msg void OnBnClickedCheckCw();
	afx_msg void OnBnClickedRadioAsiOut();
	afx_msg void OnBnClickedRadioAsiIn();
	afx_msg void OnBnClickedRadioRfOut();
	afx_msg void OnBnClickedRadioAsiRf();
	afx_msg void OnBnClickedRadioRfOutRaw();

	afx_msg LRESULT OnChangeBcType(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSourceBitRate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDVB_TH_SymbolRate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDVB_TH_OutBitRate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCMMB_OutBitRate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnTDMB_TM_Mode(WPARAM wParam, LPARAM lParam);
	

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()	

public:
	VOID UpdateGUI(VOID);
	VOID UpdateBcTypeRadioCtrl(VOID);

private:
	VOID InitComboCtrl(CComboBox* pCombo = NULL, CWnd* pWnd = NULL, BOOL isEnable = TRUE);

private:
	CWinThread* mp_ThreadHandle;
	CButton m_checkCW;	

	//Play time
	CString		m_strTotaltime_milli;
	CString		m_strTotaltime_Sec;
	CString		m_strTotaltime_Min;
	CString		m_strTotaltime_Hou;
	UINT		mu4_TotalTime_milli; //1 == 10ms
	UINT		mu4_TotalTime_Sec;
	UINT		mu4_TotalTime_Min;
	UINT		mu4_TotalTime_Hou;
	ULONGLONG	mu8_TestTime;	
	
public:
	afx_msg void OnCbnSelchangeComboCodeRate();
	afx_msg void OnCbnSelchangeComboConstellation();
	afx_msg void OnCbnSelchangeComboIfft();
	afx_msg void OnCbnSelchangeComboOutTsType();
	afx_msg void OnCbnSelchangeComboSourceTsType();
	afx_msg void OnCbnSelchangeComboGuardInterval();
	afx_msg void OnCbnSelchangeComboInterleaver();
	afx_msg void OnCbnSelchangeComboBw();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedCheckRemux();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnEnKillfocusEditSourceRate();
	afx_msg void OnEnKillfocusEditOutRate();
	afx_msg void OnEnKillfocusEditSymbolRate();
	afx_msg void OnEnKillfocusEditFrequency();
	afx_msg void OnEnKillfocusEditLevel();
};
