#pragma once 

#include "ventus.h"

enum _VentusMessage
{
	VTS_MSG_SOURCE_BITRATE = WM_USER + 1,	
	VTS_MSG_CHANGE_BC_TYPE,
	VTS_MSG_DVB_TH_SYMBOL_RATE,
	VTS_MSG_DVB_TH_OUT_BITRATE,
	VTS_MSG_CMMB_OUT_BITRATE,
	VTS_MSG_TDMB_TM_MODE,
	
};

typedef struct _VtsControlContext
{
	VTS_BroadcastType_t t_BcType;
	VTS_PumpMode_t      t_PumpMode;

	VTS_TS_Format_t     t_OutTsFormat;
	VTS_TS_Format_t     t_SrcTsFormat;

	VTS_PumpState_t     t_PumpState;
	
	//Group of Bit / Symbol rate 
	UINT u4_SourceRate_bps;
	UINT u4_ASI_OUT_OutRate_bps;
	UINT u4_SymbolRate_bd;
	bool u4_isRemux;

	//Group of RF
	UINT  u4_Frequency_hz;
	short s2_Level_01dBm;
	UINT  u4_AttenFreq_Hz;
	UCHAR u1_OnOffAttenPlus; 

	//In file path/name
	CString strInFilePathName;

//For modulator parameter	
	//CW
	USHORT u2_CW_LevelCtrl;
	bool   isCW_Level_20dBm;

	//DVB-TH
	VTS_DVB_TH_CodeRate_t		t_DVBTH_CodeRate;
	VTS_DVB_TH_Constel_t		t_DVBTH_Constel;
	VTS_DVB_TH_TxMode_t			t_DVBTH_TxMode;
	UCHAR						u1_DVBTH_BW_MHz;	
	VTS_DVB_TH_Interleaver_t	t_DVBTH_Interleaver;
	VTS_DVB_TH_GuardInt_t		t_DVBTH_GuardInt;

	//DVB-TH for additional function
	USHORT 						u2_DVBTH_CellID;
	bool   						isDVBTH_CellID;	
	bool   						isDVBTH_UseMPE_FEC;
	bool   						isDVBTH_UseTimeSlicing;
	bool   						isDVBTH_HEnable;		

	//DVB-C
	UINT u4_DVBC_SymRate_bd;
	UINT u4_DVBC_BitRate_bps;
	VTS_DVB_C_Constel_t t_DVBC_Constel;

	//T-DMB
	bool b_TDMB_TIIEnable;
	UCHAR u1_TDMB_MainId;
	UCHAR u1_TDMB_SubId;

	//ISDB-T
	ISDB_Layer_Parameter_t	t_ISDBT_Layer_A_Parameter;
	ISDB_Layer_Parameter_t	t_ISDBT_Layer_B_Parameter;
	ISDB_Layer_Parameter_t	t_ISDBT_Layer_C_Parameter;
	ISDB_OfdmConfig_t		t_ISDBT_OFDM_Config;

	//QAM-B(OepnCable)
	VTS_QAM_B_Constel_t			t_QAMB_Constel;
	VTS_QAM_B_Interleaving_t	t_QAMB_Interleaving;

	//CMMB	
	INT				s4_CMMB_MFID_For_Delete;
	CmmbConfig_t	t_CMMB_Config;
	CmmbInformation_t t_CMMB_CLCH_Parameter;
	unsigned int	u4_CMMB_Changed_Index;		
//	vector<UINT>	m_vecCmmb_Deleted_ID;

}VTSCC_t;

typedef struct _VtsUpdateContext
{
	bool isBcTypeSupport[VTS_BC_MAX];

	//Atten-Plus
	bool isExistAttenPlus;	
	short s2_AttenMax_01dBm;
	short s2_AttenMin_01dBm;
	UINT  u4_AttenMax_Hz;
	UINT  u4_AttenMin_Hz;
	CHAR  s1_Atten_Celsius;
	VTS_AttenuatorID_t t_AttenuatorID;

	//Size of In-File 
	ULONGLONG u8_InFileBytes;	
	INT       s4_OffSetSourceFile;

	UINT u4_HwBufferUsed;
	UINT u4_HwBufferSize;


	//DVB-TH
	UINT u4_DVBTH_BitRate_bps;
	UINT u4_DVBTH_SymRate_bd;

	//ISDB-Tb
	INT s4_ISDBT_FrameSize;

	//CMMB
	bool isCMMB_MultiCH;		
	UINT u4_CMMB_FrameSize;
	UINT u4_CMMB_SrcBitRate_bps;
	UINT u4_CMMB_OutBitRate_bps;	
	UINT u4_CMMB_SyncError;	

	//T-DMB
	UINT u4_TDMB_SrcBitRate_bps;
	UINT u4_TDMB_OutBitRate_bps;
	INT  s4_TDMB_TM;

}VTSUC_t;

typedef struct _VtsUpdateFlag
{
	//DVB-TH
	bool isDVBTH_BitRate_bps;

}VTSUF_t;


/*
switch (gt_VtsCCget.t_BcType)
{
case VTS_BC_CW:     break;
case VTS_BC_DVB_S:	break;
case VTS_BC_DVB_S2:	break;
case VTS_BC_DVB_T:  break;
case VTS_BC_DVB_H:  break;	
case VTS_BC_DVB_C:  break;
case VTS_BC_ATSC:	break;
case VTS_BC_QAM_B:	break;
case VTS_BC_QAM_C:	break;
case VTS_BC_ISDB_T:	break;
case VTS_BC_T_DMB:	break;
case VTS_BC_DTMB:	break;
case VTS_BC_CMMB:	break;
}
*/